#
# sprava virtualu
#
#
import signal, subprocess, struct, fcntl
import re, tempfile, time, datetime, os, string, random, traceback, select, socket, base64, shutil, errno, signal
import hashlib
import urllib2
import threading # pouzijeme na spousteni dom.migrate() ve vlakne
import traceback
import rfoo
from socket import inet_aton, inet_ntoa
try:
	import libvirt
	import json
	from zipfile import ZipFile
except:
	pass
import sys
# begin - pro produkci ke smazani
sys.path.append('../')
import base
import dioutil
# end
from xml.dom.minidom import parseString
from xml.dom.minidom import parse

state_table = ['unknown', 'running', 'blocked', 'paused', 'shutting down', 'shut off', 'crashed']
vg_name = 'HostVG'

def floppy_with_kickstart(vhost_name,vhost_image_type,vhost_root_password):
	# zatim nevyuzivana funkce od andreie
	# ucelem ma byt instalace centosu na vps s preddefinovanymi konfigurakmi od nas 
	random_password = ''.join(random.choice(string.ascii_letters+string.digits) for i in range(10))
	base.shell_exec2("dd if=/dev/zero of=/tmp/floppy_%s.img count=1440 bs=1k" % vhost_name) # vytvarime prazdnou disketu
	out,err,ret = base.shell_exec2("/sbin/mkfs.msdos /tmp/floppy_%s.img" % vhost_name)
	if ret != 0:
		return [False, 'Nelze vytvorit floppy disk s kickstartem. %s. %s' % (out,err)]
	#ks_content = open("/root/server/kickstarts/%s.cfg" % vhost_image_type).read()
	ks_content = urllib2.urlopen("https://administrace.hosting90.cz/download/kickstarts/" + vhost_image_type).read()
	ks_content = ks_content.replace("ROOTPW_HERE",vhost_root_password).replace("MYSQL_PASSWD_IS_HERE",random_password)
	open('/tmp/ks_%s.cfg' % vhost_name,'w').write(ks_content)
	out,err,ret = base.shell_exec2("mcopy -i /tmp/floppy_%s.img /tmp/ks_%s.cfg ::/ks.cfg" % (vhost_name,vhost_name))# copy kickstart
	if ret != 0:
		return [False, 'Nepodarilo se nakopirovat kickstart %s.cfg na disketu. %s. %s' % (vhost_image_type,out,err)]
	# nasledujici shell_exec2 chybove vystupy jsou ignorovane
	base.shell_exec2("mcopy -i /tmp/floppy_%s.img /root/server/kickstarts/files/%s.id_rsa ::/id_rsa" % (vhost_name,vhost_image_type))
	base.shell_exec2("mcopy -i /tmp/floppy_%s.img /root/server/kickstarts/files/%s.id_rsa.pub ::/id_rsa.pub" % (vhost_name,vhost_image_type))
	return [True,'']

def lvcreate_disk_space(volume_group,vhost_name,disk_space,disk_stripped,create_new_vps=False,create_additional_disk_space=False):
	# v argumentu vhost_name vzdy dostaneme (vhost['name'])
	# v argumentu disk_space dostaneme (vhost['disk_space']) nebo (vhost['additional_disk_space'])
	if create_additional_disk_space:
		lv_name = vhost_name + '_a'
	else:
		lv_name = vhost_name
	if os.system('lvs '+volume_group+'/thinpool >/dev/null 2>&1') == 0 and not create_additional_disk_space:
		# thin provisioning (additional nevyrabime na SSD)
		res = base.shell_exec2("lvcreate -T "+volume_group+"/thinpool -n"+lv_name+" -V"+disk_space+"G 2>&1")
	elif not disk_stripped:
		if create_additional_disk_space:
			dev = base.shell_exec("pvs --noheadings --separator ' ' -o pv_name,vg_name,lv_name | grep "+volume_group+" | grep "+vhost_name+" | awk '{print $1}'")
		else:
			dev = base.shell_exec("pvs --noheadings --separator ' ' -o pv_name,vg_name --sort pv_free | grep "+volume_group+" | tail -n1 | awk '{print $1}'")
		res = base.shell_exec2("lvcreate -n"+lv_name+" -L"+disk_space+"G "+volume_group+" "+dev)
	else:
		pvs = base.shell_exec("pvs --noheadings -o pv_name,pv_attr,vg_name | egrep '"+volume_group+"$' | egrep ' a'| wc -l").strip()
		thin_pvs = base.shell_exec("pvs --noheadings -o pv_name,pv_attr,vg_name,lv_name | egrep '"+volume_group+"$' | grep thinpool | awk '{print $1}' | uniq | wc -l")
		pvs = int(pvs) - int(thin_pvs)
		if pvs > 1:
			res = base.shell_exec2("lvcreate -i "+str(pvs)+" -I 1024 -n"+lv_name+" -L"+disk_space+"G "+volume_group)
		else:
			res = base.shell_exec2("lvcreate -C y -n"+lv_name+" -L"+disk_space+"G "+volume_group)
	## bylo zakomentovano, pro jistotu tak nechame
	#res = base.shell_exec('virsh vol-create --pool '+volume_group+' --file '+conf_path+vhost['name']+'-vol.xml')
	#res = base.shell_exec('virsh vol-create-as --pool '+volume_group+' --capacity '+vhost['disk_space']+'G --name '+vhost['name'])

	# diskovy volume pro nove vps se nepodarilo vytvorit, tak koncime driv
	if (create_new_vps and (res[0].find("created") == -1)):
		return res
	base.shell_exec("lvchange -r 16384 /dev/%s/%s >/dev/null 2>&1" % (volume_group, lv_name))
	return res

def lvm_resize(volume_group,vhost_name,disk_space,lvm_size,force_resize=0,resize_additional_disk_space=False,resize_za_behu=False):
	# menime velikost volumu
	# v argumentu vhost_name vzdy dostaneme (vhost['name'])
	# v argumentu disk_space dostaneme (vhost['disk_space']) nebo (vhost['additional_disk_space'])
	# v argumentu lvm_size dostaneme (lvm['data']['LVM2_LV_SIZE'].strip('gG')) nebo (additional_lvm['data']['LVM2_LV_SIZE'].strip('gG'))
	if resize_additional_disk_space:
		lv_name = vhost_name + '_a'
	else:
		lv_name = vhost_name
	# vetev pro (vhost['disk_space'])
	if not resize_additional_disk_space and (float(lvm_size) < float(disk_space) or force_resize == 1):
		# force_resize se funkci lvm_resize predava pouze kdyz mame restart/reinstal, jinak ma default hodnotu 0
		res = base.shell_exec('lvchange -Cn '+volume_group+'/'+lv_name+' 2>&1')
		if res.find('changed') == -1 and res.find('already inherit') == -1:
			return [False, res]
		res = base.shell_exec('lvresize -f -L'+disk_space+'G '+volume_group+'/'+lv_name+' 2>&1')
		if res.find('successfully resized') == -1 and res.find('matches existing size') == -1:
			return [False, res]
		res = base.shell_exec('lvchange -Cy '+volume_group+'/'+lv_name+' 2>&1')
		# tady se podminky pri lvm_resize za behu vps lisi, pro jistotu ponechavam
		if not resize_za_behu and res.find('changed') == -1 and res.find('already contiguous') == -1:
			return [False, res]
		if resize_za_behu and res.find('changed') == -1:
			return [False, res]
	# vetev pro (vhost['additional_disk_space'])
	# v kodu se provadela pouze pri restartu/reinstalu vps, pro jistotu ponechavam
	elif not resize_za_behu and resize_additional_disk_space and (float(lvm_size) < float(disk_space)):
		res = base.shell_exec('lvresize -f -L'+disk_space+'G '+volume_group+'/'+lv_name+' 2>&1')
		if res.find('successfully resized') == -1 and res.find('matches existing size') == -1:
			return [False, res]
	# zmenseni volumu nepodporujeme, budeme tise ignorovat
	elif float(lvm_size) > float(disk_space):
		pass
	return [True,'']

def libvirt_error_handler(ctr, err):
	#chyby ignorujeme, vraci se v exceptione
	pass
	return 1

try:
	libvirt.registerErrorHandler(libvirt_error_handler, 1)
except:
	pass

def vhost_nwfilter_xml(vhost_data):
	ipv4 = []
	for subnet in vhost_data['nwfilter'].getElementsByTagName('subnet'):
		text_data = base.getText(subnet.childNodes)
		if re.match('^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/[0-9]{1,2}$', text_data) != None:
			ipv4.append(base.getText(subnet.childNodes).split("/"))
	if len(ipv4) == 0:
		return None
	else:
		lines = []
		lines.append("<filter name='nwfilter_%s'>" % (vhost_data['name']))
		for subnet in ipv4:
			lines.append('''<rule action='return' direction='out' priority='-100'>
				<ip srcipaddr='%s' srcipmask='%s'/>
			</rule>''' % (subnet[0], subnet[1]))
		if vhost_data['nwfilter_name'] != '':
			filterref = vhost_data['nwfilter_name']
		else:
			filterref = 'filter-vps-default'
		lines.append("<filterref filter='%s'/>" % (filterref))
		lines.append("</filter>")
		xmlout = "\n".join(lines)
		virt_path = '/usr/virt/'
		conf_path = virt_path+'conf/'
		conf_file = open(conf_path+'nwfilter_'+vhost_data['name']+'.xml', "w")
		conf_file.write(xmlout)
		conf_file.close()
		return xmlout

def vhost_virsh_xml(vhost_data):
	# nwfilter = vhost_nwfilter_xml(vhost_data)
	# conn = libvirt.open(None)
	# 
	# if nwfilter != None:
	# 	try:
	# 		conn.nwfilterDefineXML(nwfilter)
	# 		vhost_data['nwfilter_name'] = 'nwfilter_%s' % (vhost_data['name'])
	# 	except:
	# 		pass
	# else:
	# 	myfilter = conn.nwfilterLookupByName('nwfilter_%s' % (vhost_data['name']))
	# 	if myfilter != None:
	# 		myfilter.undefine()
	# 
	# conn.close()
	
	drive_letters = map(chr,range(ord('a'),ord('z')+1,1))
	
	if not vhost_data.has_key('autostart'):
		try:
			conn = libvirt.open(None)
			dom = conn.lookupByName(vhost_data['name'])
			xml = parseString(dom.XMLDesc(libvirt.VIR_DOMAIN_XML_INACTIVE))
			vhost_data['autostart'] = xml.getElementsByTagName('metadata')[0].getElementsByTagName('c2pauto:metadata')[0].getElementsByTagName('autostart')[0].childNodes[0].data
			conn.close()
		except:
			pass
		
			
	ipv4 = []
	ipv6 = []
	for subnet in vhost_data['nwfilter'].getElementsByTagName('subnet'):
		text_data = base.getText(subnet.childNodes)
		if re.match('^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/[0-9]{1,2}/[01]$', text_data) != None:
			ipv4.append(base.getText(subnet.childNodes).split("/"))
		if re.match('^((::([0-9a-f]{1,4}:){0,5}([0-9a-f]{1,4})?)|(([0-9a-f]{1,4})::([0-9a-f]{1,4}:){0,5}([0-9a-f]{1,4})?)|(([0-9a-f]{1,4})(:[0-9a-f]{1,4})::([0-9a-f]{1,4}:){0,4}([0-9a-f]{1,4})?)|(([0-9a-f]{1,4})(:[0-9a-f]{1,4}){2}::([0-9a-f]{1,4}:){0,3}([0-9a-f]{1,4})?)|(([0-9a-f]{1,4})(:[0-9a-f]{1,4}){3}::([0-9a-f]{1,4}:){0,2}([0-9a-f]{1,4})?)|(([0-9a-f]{1,4})(:[0-9a-f]{1,4}){4}::([0-9a-f]{1,4}:)?([0-9a-f]{1,4})?)|(([0-9a-f]{1,4})(:[0-9a-f]{1,4}){5}::([0-9a-f]{1,4})?)|(([0-9a-f]{1,4})(:[0-9a-f]{1,4}){6}:((:)|([0-9a-f]{1,4})?)))/[0-9]{1,3}/[01]$', text_data) != None:
			ipv6.append(base.getText(subnet.childNodes).split("/"))
		
	
	
	if vhost_data['interface'] == 'br0':
		if re.match('^coh-', socket.gethostname()) == None:
			vhost_data['interface'] = 'vbr100'
		else:
			vhost_data['interface'] = 'vbr101'
		
	xml = parse("virtual-template.xml")
	
	kversion = os.uname()[2].split('-')
	if not vhost_data.has_key('nic_type'):
		vhost_data['nic_type'] = 'virtio'
	if not vhost_data.has_key('watchdog_type'):
		vhost_data['watchdog_type'] = 'i6300esb'
		
	# cgroupy
	xml.getElementsByTagName('blkiotune')[0].getElementsByTagName('weight')[0].childNodes[0].data = vhost_data['disk_io_weight']
	xml.getElementsByTagName('cputune')[0].getElementsByTagName('shares')[0].childNodes[0].data = vhost_data['cpu_share']
	xml.getElementsByTagName('cputune')[0].getElementsByTagName('quota')[0].childNodes[0].data = vhost_data['cpu_quota']
	if not vhost_data['hyperv_extensions']:
		xml.getElementsByTagName('features')[0].removeChild(xml.getElementsByTagName('features')[0].getElementsByTagName('hyperv')[0])
	if not vhost_data['memory_deduplication']:
		xml.getElementsByTagName('memoryBacking')[0].appendChild(xml.createElement('nosharepages'))
	metadata = xml.getElementsByTagName('metadata')[0].getElementsByTagName('c2pauto:metadata')[0]
	diskdevice = parseString('<xml>'+vhost_data['diskdevice']+'</xml>')
	if not vhost_data['autobackup']:
		metadata.getElementsByTagName('autobackup')[0].childNodes[0].data = vhost_data['autobackup']
	if vhost_data.has_key('autostart'):
		metadata.getElementsByTagName('autostart')[0].childNodes[0].data = vhost_data['autostart']
	
	metadata.getElementsByTagName('cpu_burst_quota')[0].childNodes[0].data = vhost_data['cpu_quota']	
	metadata.getElementsByTagName('cpu_hard_quota')[0].childNodes[0].data = vhost_data['cpu_hard_quota']
	metadata.getElementsByTagName('disk_read_mbps')[0].childNodes[0].data = vhost_data['disk_read_mbps']
	metadata.getElementsByTagName('disk_write_mbps')[0].childNodes[0].data = vhost_data['disk_write_mbps']
	metadata.getElementsByTagName('disk_read_iops')[0].childNodes[0].data = vhost_data['disk_read_iops']
	metadata.getElementsByTagName('disk_write_iops')[0].childNodes[0].data = vhost_data['disk_write_iops']
	
	xml.getElementsByTagName('name')[0].childNodes[0].data = vhost_data['name']
	xml.getElementsByTagName('uuid')[0].childNodes[0].data = vhost_data['uuid']
	xml.getElementsByTagName('memory')[0].childNodes[0].data = vhost_data['memory_max']
	xml.getElementsByTagName('currentMemory')[0].childNodes[0].data = vhost_data['memory_min']
	xml.getElementsByTagName('vcpu')[0].childNodes[0].data = str(int(vhost_data['cpu'])*int(vhost_data['threads']))
	xml.getElementsByTagName('cpu')[0].getElementsByTagName('topology')[0].setAttribute('cores', vhost_data['cpu'])
	xml.getElementsByTagName('cpu')[0].getElementsByTagName('topology')[0].setAttribute('threads', vhost_data['threads'])
	xml.getElementsByTagName('sysinfo')[0].getElementsByTagName('bios')[0].getElementsByTagName('entry')[0].childNodes[0].data = vhost_data['vendor']
	xml.getElementsByTagName('sysinfo')[0].getElementsByTagName('system')[0].getElementsByTagName('entry')[0].childNodes[0].data = vhost_data['vendor']
	if vhost_data['clock_type'] == 'utc' or vhost_data['clock_type'] == 'localtime':
		xml.getElementsByTagName('clock')[0].setAttribute('offset', vhost_data['clock_type'])
	else:
		xml.getElementsByTagName('clock')[0].setAttribute('offset', 'timezone')
		xml.getElementsByTagName('clock')[0].setAttribute('timezone', vhost_data['clock_type'])
	xml.getElementsByTagName('clock')[0].getElementsByTagName('timer')[1].setAttribute('tickpolicy', vhost_data['rtc_tickpolicy'])
	devices = xml.getElementsByTagName('devices')[0]
	devices.getElementsByTagName('video')[0].getElementsByTagName('model')[0].setAttribute('type', vhost_data['graphics_type'])
	devices.getElementsByTagName('serial')[0].getElementsByTagName('source')[0].setAttribute('path', '/var/lib/libvirt/qemu/'+vhost_data['name']+'.com1')
	devices.getElementsByTagName('channel')[0].getElementsByTagName('source')[0].setAttribute('path', '/var/lib/libvirt/qemu/'+vhost_data['name']+'.vport')
	devices.getElementsByTagName('channel')[1].getElementsByTagName('source')[0].setAttribute('path', '/var/lib/libvirt/qemu/'+vhost_data['name']+'.agent')
	if base.get_os_name()[1] == '7': #upravy pro CENTOS 7
		vapic = xml.createElement('vapic')
		vapic.setAttribute('state','on')
		spinlocks = xml.createElement('spinlocks')
		spinlocks.setAttribute('state','on')
		spinlocks.setAttribute('retries','8191')
		if vhost_data['hyperv_extensions']:
			hyperv = xml.getElementsByTagName('hyperv')[0]
			# s timhle virtualy po migraci nebootuji
			# https://bugzilla.redhat.com/show_bug.cgi?id=1091818
			# https://rhn.redhat.com/errata/RHSA-2015-0290.html
			# opraveno v kernel-3.10.0-229.el7.x86_64.rpm
			# zatim neni v CentOSu
			#hyperv.appendChild(vapic)
			hyperv.appendChild(spinlocks)
			
			hypervclock = xml.createElement('timer')
			hypervclock.setAttribute('name','hypervclock')
			hypervclock.setAttribute('present','yes')
			clock = xml.getElementsByTagName('clock')[0]
			clock.appendChild(hypervclock)
		
		commandline = xml.getElementsByTagName('qemu:commandline')[0]
		arg = xml.createElement('qemu:arg')
		arg.setAttribute('value', '-qmp')
		commandline.appendChild(arg)
		arg = xml.createElement('qemu:arg')
		arg.setAttribute('value', 'unix:/var/lib/libvirt/qemu/%s.qmpcustom,server,nowait' % (vhost_data['name'],))
		commandline.appendChild(arg)
		
	vnc = devices.getElementsByTagName('graphics')[0]
	vnc.setAttribute('type', str(vhost_data['display_type']))
	vnc.setAttribute('listen', str(vhost_data['vnc_listen']))
	vnc.setAttribute('port', str(vhost_data['vnc_port']))
	vnc.setAttribute('passwd', str(vhost_data['vnc_password']))
	if not vhost_data['reinstall']:
		xml.getElementsByTagName('os')[0].appendChild(xml.createElement('boot')).setAttribute('dev', 'hd')
	if diskdevice.getElementsByTagName('target')[0].getAttribute('bus') != 'scsi':
		xml.getElementsByTagName('devices')[0].removeChild(xml.getElementsByTagName('devices')[0].getElementsByTagName('controller')[0])
		# volba device='lun' (scsi passthrough) neni podporovana v centos 6 (scsi-block: scsi generic interface too old)
		# for disk in xml.getElementsByTagName('devices')[0].getElementsByTagName('disk'):
		# 	if disk.getAttribute('device') == 'lun':
		# 		disk.setAttribute('device', 'disk')
	disk = xml.getElementsByTagName('devices')[0].getElementsByTagName('disk')[0]
	drive_letter = drive_letters.pop(0)
	# if vhost_data['diskdevice'] == '<target bus="ide" dev="hda"/>':
	# 	xml.getElementsByTagName('devices')[0].getElementsByTagName('interface')[0].getElementsByTagName('model')[0].setAttribute('type', 'rtl8139')
	disk.getElementsByTagName('source')[0].setAttribute('dev', vhost_data['disk'])
	disk.replaceChild(diskdevice.getElementsByTagName('target')[0],disk.getElementsByTagName('target')[0])
	if disk.getElementsByTagName('target')[0].getAttribute('bus') != 'virtio' and disk.getElementsByTagName('target')[0].getAttribute('bus') != 'scsi':
		if disk.getElementsByTagName('driver')[0].hasAttribute('ioeventfd'):
			disk.getElementsByTagName('driver')[0].removeAttribute('ioeventfd')
		if disk.getElementsByTagName('driver')[0].hasAttribute('event_idx'):
			disk.getElementsByTagName('driver')[0].removeAttribute('event_idx')
	disk.getElementsByTagName('driver')[0].setAttribute('cache', vhost_data['disk_cache'])
	disk2 = xml.getElementsByTagName('devices')[0].getElementsByTagName('disk')[2]
	disk3 = xml.getElementsByTagName('devices')[0].getElementsByTagName('disk')[3]
	if int(vhost_data['additional_disk_space']) == 0:
		xml.getElementsByTagName('devices')[0].removeChild(xml.getElementsByTagName('devices')[0].getElementsByTagName('disk')[1])
	else:
		disk = xml.getElementsByTagName('devices')[0].getElementsByTagName('disk')[1]
		drive_letter = drive_letters.pop(0)
		disk.getElementsByTagName('source')[0].setAttribute('dev', vhost_data['disk']+'_a')
		diskdevice = parseString('<xml>'+vhost_data['diskdevice'].replace('hda', 'hd%s' % (drive_letter,)).replace('vda', 'vd%s' % (drive_letter,)).replace('sda', 'sd%s' % (drive_letter,))+'</xml>')
		disk.replaceChild(diskdevice.getElementsByTagName('target')[0],disk.getElementsByTagName('target')[0])
		if disk.getElementsByTagName('target')[0].getAttribute('bus') != 'virtio' and disk.getElementsByTagName('target')[0].getAttribute('bus') != 'scsi':
			if disk.getElementsByTagName('driver')[0].hasAttribute('ioeventfd'):
				disk.getElementsByTagName('driver')[0].removeAttribute('ioeventfd')
			if disk.getElementsByTagName('driver')[0].hasAttribute('event_idx'):
				disk.getElementsByTagName('driver')[0].removeAttribute('event_idx')
		disk.getElementsByTagName('driver')[0].setAttribute('cache', vhost_data['disk_cache'])
		
	if vhost_data['reinstall']:
		xml.getElementsByTagName('os')[0].appendChild(xml.createElement('boot')).setAttribute('dev', 'cdrom')
		xml.getElementsByTagName('os')[0].appendChild(xml.createElement('boot')).setAttribute('dev', 'hd')
		
		isos = vhost_data['iso'].split(";")
		source2 = disk2.appendChild(xml.createElement('source'))
		source2.setAttribute('file', isos[0])
		if len(isos) > 1:
			source3 = disk3.appendChild(xml.createElement('source'))
			source3.setAttribute('file', isos[1])
		else:
			devices.removeChild(disk3)
		if re.search('custom-centos', vhost_data['iso']):
			fddisk = xml.createElement("disk") # tag disk
			fddisk.setAttribute('type','file')
			fddisk.setAttribute('device','floppy')
			fddriver = xml.createElement("driver") # tag driver
			fddriver.setAttribute('name', 'qemu')
			fddriver.setAttribute('type', 'raw')
			fdsource = xml.createElement("source") # tag source
			fdsource.setAttribute('file', '/tmp/floppy_%s.img' % vhost_data['name'])
			fdtarget = xml.createElement("target") # tag target
			fdtarget.setAttribute('dev', 'fda')
			fdtarget.setAttribute('bus', 'fdc')
			fddisk.appendChild(fddriver) #stavime hierarchii
			fddisk.appendChild(fdsource)
			fddisk.appendChild(fdtarget)
			xml.getElementsByTagName('devices')[0].appendChild(fddisk)
		
	devices = xml.getElementsByTagName('devices')[0]
	if vhost_data['watchdog_type'] == 'none':
		devices.removeChild(devices.getElementsByTagName('watchdog')[0])
	else:
		devices.getElementsByTagName('watchdog')[0].setAttribute('model', vhost_data['watchdog_type'])
	if vhost_data.has_key('disable_default_vlan') and vhost_data['disable_default_vlan'] == 1:
		devices.removeChild(devices.getElementsByTagName('interface')[0])
	else:
		# network interface up/down
		if vhost_data['blocked_network']:
			devices.getElementsByTagName('interface')[0].getElementsByTagName('link')[0].setAttribute('state', 'down')
		else:
			devices.getElementsByTagName('interface')[0].getElementsByTagName('link')[0].setAttribute('state', 'up')
		devices.getElementsByTagName('interface')[0].getElementsByTagName('mac')[0].setAttribute('address', vhost_data['mac'])
		devices.getElementsByTagName('interface')[0].getElementsByTagName('source')[0].setAttribute('bridge', vhost_data['interface'])
		devices.getElementsByTagName('interface')[0].getElementsByTagName('target')[0].setAttribute('dev', 'vps'+str(vhost_data['recid']))
		if vhost_data['ipv4_filter'] != 1:
			devices.getElementsByTagName('interface')[0].removeChild(devices.getElementsByTagName('interface')[0].getElementsByTagName('ip')[0])
			devices.getElementsByTagName('interface')[0].getElementsByTagName('filterref')[0].setAttribute('filter', 'open-ip-policy')
		else:
			if vhost_data['nwfilter_name'] != '':
				devices.getElementsByTagName('interface')[0].getElementsByTagName('filterref')[0].setAttribute('filter', vhost_data['nwfilter_name'])
			if vhost_data['ip'] != '':
				devices.getElementsByTagName('interface')[0].getElementsByTagName('ip')[0].setAttribute('address', vhost_data['ip'])
		
		# Definice parametru filtru
		filterrefParam = devices.getElementsByTagName('interface')[0].getElementsByTagName('filterref')[0].appendChild(xml.createElement('parameter'))
		filterrefParam.setAttribute('name','MAC')
		filterrefParam.setAttribute('value', base.xml_cut(vhost_data['nwfilter'], 'mac'))
		if vhost_data['ip'] != '':
			for ip in vhost_data['nwfilter'].getElementsByTagName('ip'):
				filterrefParam = devices.getElementsByTagName('interface')[0].getElementsByTagName('filterref')[0].appendChild(xml.createElement('parameter'))
				filterrefParam.setAttribute('name','IP')
				filterrefParam.setAttribute('value', base.getText(ip.childNodes))
			ip6_elements = vhost_data['nwfilter'].getElementsByTagName('ip6')
			if len(ip6_elements) > 0:
				for ip6 in vhost_data['nwfilter'].getElementsByTagName('ip6'):
					filterrefParam = devices.getElementsByTagName('interface')[0].getElementsByTagName('filterref')[0].appendChild(xml.createElement('parameter'))
					filterrefParam.setAttribute('name','IPV6')
					filterrefParam.setAttribute('value', base.getText(ip6.childNodes))
			else:
				filterrefParam = devices.getElementsByTagName('interface')[0].getElementsByTagName('filterref')[0].appendChild(xml.createElement('parameter'))
				filterrefParam.setAttribute('name','IPV6')
				filterrefParam.setAttribute('value', '::1')
			for subnet in ipv4:
				if subnet[2] == '1':
					filterrefParam = devices.getElementsByTagName('interface')[0].getElementsByTagName('filterref')[0].appendChild(xml.createElement('parameter'))
					filterrefParam.setAttribute('name','IPV4_SUBNET')
					filterrefParam.setAttribute('value', subnet[0])
					filterrefParam = devices.getElementsByTagName('interface')[0].getElementsByTagName('filterref')[0].appendChild(xml.createElement('parameter'))
					filterrefParam.setAttribute('name','IPV4_NETMASK')
					filterrefParam.setAttribute('value', subnet[1])
				else:
					startip = struct.unpack('!L', inet_aton(subnet[0]))[0]
					netlen = 1<<(32-int(subnet[1]))
					for ip in range(startip, startip+netlen):
						filterrefParam = devices.getElementsByTagName('interface')[0].getElementsByTagName('filterref')[0].appendChild(xml.createElement('parameter'))
						filterrefParam.setAttribute('name','IP')
						filterrefParam.setAttribute('value', inet_ntoa(struct.pack('!L', ip)))
			for subnet in ipv6:
				filterrefParam = devices.getElementsByTagName('interface')[0].getElementsByTagName('filterref')[0].appendChild(xml.createElement('parameter'))
				filterrefParam.setAttribute('name','IPV6_SUBNET')
				filterrefParam.setAttribute('value', subnet[0])
				filterrefParam = devices.getElementsByTagName('interface')[0].getElementsByTagName('filterref')[0].appendChild(xml.createElement('parameter'))
				filterrefParam.setAttribute('name','IPV6_NETMASK')
				filterrefParam.setAttribute('value', subnet[1])
				
		# Filterref  end
		
		
		devices.getElementsByTagName('interface')[0].getElementsByTagName('model')[0].setAttribute('type', vhost_data['nic_type'])
		if vhost_data['nic_type'] != 'virtio':
			if devices.getElementsByTagName('interface')[0].hasAttribute('ioeventfd'):
				devices.getElementsByTagName('interface')[0].removeAttribute('ioeventfd')
			if devices.getElementsByTagName('interface')[0].hasAttribute('event_idx'):
				devices.getElementsByTagName('interface')[0].removeAttribute('event_idx')
		if vhost_data['limit_traffic_in'] != '' or vhost_data['limit_traffic_out'] != '':
			if vhost_data['limit_traffic_in'] != '':
				devices.getElementsByTagName('interface')[0].getElementsByTagName('bandwidth')[0].getElementsByTagName('inbound')[0].setAttribute('average', vhost_data['limit_traffic_in'])
			else:
				devices.getElementsByTagName('interface')[0].getElementsByTagName('bandwidth')[0].removeChild(devices.getElementsByTagName('interface')[0].getElementsByTagName('bandwidth')[0].getElementsByTagName('inbound')[0])
			if vhost_data['limit_traffic_out'] != '':
				devices.getElementsByTagName('interface')[0].getElementsByTagName('bandwidth')[0].getElementsByTagName('outbound')[0].setAttribute('average', vhost_data['limit_traffic_out'])
			else:
				devices.getElementsByTagName('interface')[0].getElementsByTagName('bandwidth')[0].removeChild(devices.getElementsByTagName('interface')[0].getElementsByTagName('bandwidth')[0].getElementsByTagName('outbound')[0])
		else:
			devices.getElementsByTagName('interface')[0].removeChild(devices.getElementsByTagName('interface')[0].getElementsByTagName('bandwidth')[0])
		
			
		
	for item in vhost_data['vlans'].getElementsByTagName('item'):
		mac, address, port, vlan_id, vlan_type, vxlan_id = base.xml_cut(item, ['mac', 'address', 'port', 'vlan_id', 'type', 'vxlan_id'])
		interface = devices.appendChild(xml.createElement('interface'))
		interface.appendChild(xml.createElement('model')).setAttribute('type', vhost_data['nic_type'])
		interface.appendChild(xml.createElement('mac')).setAttribute('address', mac)
		interface.appendChild(xml.createElement('driver')).setAttribute('name', 'vhost')
		interface.getElementsByTagName('driver')[0].setAttribute('ioeventfd','on')
		source = interface.appendChild(xml.createElement('source'))
		target = interface.appendChild(xml.createElement('target'))
		if vlan_type in ['qinq', 'vlan', 'vxlan']:
			if vlan_type == 'vxlan':
				vlan_id = int(vlan_id)
				vxlan_id = vxlan_id.lower()
				mac = mac.lower()
				if vlan_id > 1:
					source.setAttribute('bridge', 'bx%s.%d' % (vxlan_id,vlan_id))
				else:
					source.setAttribute('bridge', 'bx%s' % (vxlan_id,))
				target.setAttribute('dev', 'vm%s' % (mac.replace(':',''),))
			elif vlan_type == 'qinq':
				# QinQ bezi na vlan2. O vytvoreni interfacu se postaraji hooky
				source.setAttribute('bridge', 'vbr2.%s' % (vlan_id,))
				target.setAttribute('dev', 'vps%dq%s' % (int(vhost_data['recid']),vlan_id))
			else:
				source.setAttribute('bridge', 'vbr%s' % (vlan_id,))
				target.setAttribute('dev', 'vps%dv%s' % (int(vhost_data['recid']),vlan_id))
			
			interface.setAttribute('type', 'bridge')
			filterref = interface.appendChild(xml.createElement('filterref'))
			filterref.setAttribute('filter', 'open-ip-policy')
			param = filterref.appendChild(xml.createElement('parameter'))
			param.setAttribute('name', 'MAC')
			param.setAttribute('value', mac)
		else:
			increment = base.ip2int(address) - base.ip2int('239.0.0.0')
			target.setAttribute('dev', 'vps%dm%s' % (int(vhost_data['recid']),increment))
			interface.setAttribute('type', 'mcast')
			source.setAttribute('address', address)
			source.setAttribute('port', port)
			
	if base.get_os_name()[1] == '7': #upravy pro CENTOS 7
		if len(vhost_data['direct_storage'].getElementsByTagName('item')) > 0:
			conn = libvirt.open(None)
			for item in vhost_data['direct_storage'].getElementsByTagName('item'):
				dsn, username, password, ipv4 = base.xml_cut(item, ['dsn', 'username', 'password', 'ipv4'])
				try:
					sc = conn.secretLookupByUsage(libvirt.VIR_SECRET_USAGE_TYPE_ISCSI,"%s_%s" % (dsn,username,))
				except:
					sc = conn.secretDefineXML("<secret ephemeral='no' private='yes'><description>Passphrase for the iSCSI server</description><usage type='iscsi'><target>%s_%s</target></usage></secret>" % (dsn,username,),0)
				sc.setValue(password)
				drive_letter = drive_letters.pop(0)
				disk = parse('virtual-direct-storage-template.xml')
				disk.getElementsByTagName('auth')[0].setAttribute('username', username)
				disk.getElementsByTagName('auth')[0].getElementsByTagName('secret')[0].setAttribute('usage', "%s_%s" % (dsn,username,))
				disk.getElementsByTagName('source')[0].setAttribute('name', "%s/1" % (dsn,))
				disk.getElementsByTagName('source')[0].getElementsByTagName('host')[0].setAttribute('name', "%s" % (random.choice(ipv4.split(";")),))
				disk.getElementsByTagName('target')[0].setAttribute('dev', "sd%s" % (drive_letter,))
				devices.appendChild(disk.childNodes[0])
			conn.close()
	
	xmlout = xml.toxml()
	virt_path = '/usr/virt/'
	conf_path = virt_path+'conf/'
	conf_file = open(conf_path+vhost_data['name']+'.xml', "w")
	conf_file.write(xmlout)
	conf_file.close()
	return xmlout

def vhost_devices_diff(dom):
	# accept domain resource and attach/detach drives that changed in config
	# the resource is attached/detached based on source device path
	
	new_xml = parseString(dom.XMLDesc(libvirt.VIR_DOMAIN_XML_INACTIVE))
	current_xml = parseString(dom.XMLDesc(0))
	present = {}
	new = {}
	for drive in new_xml.getElementsByTagName('devices')[0].getElementsByTagName('disk'):
		if len(drive.getElementsByTagName('source')):
			name_path = drive.getElementsByTagName('source')[0].getAttribute('name')+drive.getElementsByTagName('source')[0].getAttribute('dev')
			if len(drive.getElementsByTagName('shareable')) > 0:
				name_path += '-shareable'
			new[name_path] = drive.toxml()
	for drive in current_xml.getElementsByTagName('devices')[0].getElementsByTagName('disk'):
		if len(drive.getElementsByTagName('source')):
			name_path = drive.getElementsByTagName('source')[0].getAttribute('name')+drive.getElementsByTagName('source')[0].getAttribute('dev')
			if len(drive.getElementsByTagName('shareable')) > 0:
				name_path += '-shareable'
			present[name_path] = drive.toxml()
	add = []
	remove = []
	for k in new.keys():
		if k not in present.keys():
			add.append(new[k])
	for k in present.keys():
		if k not in new.keys():
			remove.append(present[k])
	for item in remove:
		try:
			dom.detachDeviceFlags(item,libvirt.VIR_DOMAIN_AFFECT_LIVE)
		except:
			pass
	for item in add:
		try:
			dom.attachDevice(item)
		except:
			pass
	

def vhost_shutdown(name, timeout):
	force = False
	conn = libvirt.open(None)
	try:
		dom = conn.lookupByName(name)
	except:
		conn.close()
		return [False, 'domain not present']
	set_watchdog_start(name, 0)
	#dom.setAutostart(0)
	#if os.path.exists('/etc/libvirt/qemu/autostart/'+name+'.xml'):
	#	os.unlink('/etc/libvirt/qemu/autostart/'+name+'.xml')
	# try:
	# 	res = dom.shutdownFlags(libvirt.VIR_DOMAIN_REBOOT_GUEST_AGENT)
	# except:
	try:
		res = dom.shutdownFlags(libvirt.VIR_DOMAIN_REBOOT_ACPI_POWER_BTN)
	except:
		force = True
	expiry = time.time() + timeout
	dominfo = None
	try:
		dominfo = dom.info()[0]
	except:
		pass
	while dominfo != libvirt.VIR_DOMAIN_SHUTOFF:
		if (force or time.time() > expiry) and not os.path.exists('/etc/libvirt_watchdog/'+name):
			try:
				res = dom.destroy()
			except:
				dom = conn.lookupByName(name)
				dom.setSchedulerParameters({'vcpu_quota':-1, 'emulator_quota':-1})
				time.sleep(5)
				if dom.info()[0] == libvirt.VIR_DOMAIN_SHUTOFF:
					conn.close()
					return [True, "Domain destroyed"]
				else:
					return [False, "unable to destroy domain"]
			else:
				conn.close()
				return [True, "Domain destroyed"]
		elif not os.path.exists('/etc/libvirt_watchdog/'+name):
			try: res = dom.shutdownFlags(libvirt.VIR_DOMAIN_REBOOT_ACPI_POWER_BTN)
			except: pass
			time.sleep(5)
		else: # vyskocime z cyklu, watchdog existuje, nesmime vypinat.
			break
		try: dominfo = dom.info()[0]
		except:	pass
	conn.close()
	return [True, "domain shut off"]

def read_partitions(lv_device):
	partitions = []
	regex = '^'+re.escape(lv_device)+'p?([0-9])\s*:\s*start=\s*([0-9]+),\s*size=\s*([0-9]+),\s*Id=\s*([0-9a-fA-F]+)(,\s*bootable)?$'
	table_lines = base.shell_exec("sfdisk -d "+lv_device)
	for line in table_lines.split('\n'):
		mymatch = re.match(regex, line)
		if mymatch != None and mymatch.group(4) <> "0":
			partitions.append({'id':mymatch.group(1), 'start': mymatch.group(2), 'size': mymatch.group(3), 'type': mymatch.group(4)})
	return partitions

def resize_partition(lv_device):
	mymatch = re.match('^\/dev\/HostVG\/(virtual\_[0-9]+)$', lv_device)
	if mymatch == None:
		raise ValueError('Invalid volume path: %s' % lv_device)
	dm_name = 'temp-'+mymatch.group(1)
	dm_device = '/dev/mapper/'+dm_name
	vg_active = base.shell_exec('ls -1 /dev/mapper/temp-* 2>/dev/null').strip()
	if vg_active != '':
		base.shell_exec('umount /dev/VirtVG/root')
		base.shell_exec('vgchange -an VirtVG')
		devices = vg_active.split('\n')
		for device in devices:
			base.shell_exec('dmsetup remove -f '+device)
			base.shell_exec('sleep 1')
	partitions = read_partitions(lv_device)
	if len(partitions) != 2:#pokud je tam 3 partisny, tak ta treti asi nebude systemova -> at si klienti resiznou disk rucne
		return False
	if int(partitions[0]['type']) == 7: # nesmime sahat na WINDOWS!!!
		return False
	partition = partitions.pop() # zatim plati: ta posledni = ta druha.
	# OLD (zmen. Andrei) # base.shell_exec("echo 'd\n2\nn\np\n2\n\n\nw\n' | fdisk "+lv_device)
	base.shell_exec("sleep 4; echo 'd\n2\nn\np\n2\n"+partition['start']+"\n\nt\n2\n" + partition['type'] + "\nw\n' | fdisk "+lv_device)
	partitions = read_partitions(lv_device) # znovunacteni
	partition = partitions.pop()
	# dmsetup create temp-virtual_377p1 --table "0 20762675 linear /dev/mapper/HostVG-virtual_377 208845"
	# pripojime device a aktivujeme PV
	dmsetup_tupple = (dm_name, partition['size'], lv_device, partition['start'])
	base.shell_exec('dmsetup create %s --table "0 %s linear %s %s"' % dmsetup_tupple)
	base.shell_exec('pvscan; vgchange -ay VirtVG')

	# zvetsime PV, LV a filesystem
	base.shell_exec('pvresize '+dm_device)
	base.shell_exec('lvresize -l+100%FREE /dev/VirtVG/root')
	base.shell_exec('fsck -fy /dev/VirtVG/root')
	fs_type = base.shell_exec('blkid /dev/mapper/VirtVG-root')
	m = re.search("TYPE=\"(.*)\"", fs_type)
	if m.group(1) == 'xfs':
		chroot = '/tmp/virtroottemp'
		base.shell_exec('mkdir '+chroot+'; mount /dev/VirtVG/root '+chroot)	
		base.shell_exec('xfs_growfs /dev/VirtVG/root')
		base.shell_exec('umount '+chroot+'; rm -rf '+chroot)
	else:
		base.shell_exec('resize2fs /dev/VirtVG/root')
	
	base.shell_exec('vgchange -an VirtVG')
	base.shell_exec('dmsetup remove -f '+dm_name)
	return True
	
def save_snapshot_as_image(vhost_name, target_path, target_size):
	snapshot_name = vhost_name+'-image-snapshot'
	snapshot_device = '/dev/'+vg_name+'/'+snapshot_name
	dm_name = snapshot_name+'-dm'

	size_in_bytes = target_size<<30
	total_blocks = size_in_bytes>>9

	# create snapshot
	base.shell_exec('lvcreate -s -n '+snapshot_name+' -L10G /dev/'+vg_name+'/'+vhost_name)

	partitions = read_partitions(snapshot_device)
	partition = partitions.pop()

	part_start = int(partition['start'])
	part_end = total_blocks-1
	part_size = total_blocks-part_start

	pv_size_pe = part_size>>13 # na 4 MB PE
	pv_size_k = part_size>>1
	lv_size_pe = pv_size_pe - 256 # odecitame velikost swapu

	fs_size_k = lv_size_pe<<12

	# dmsetup create temp-virtual_377p1 --table "0 20762675 linear /dev/mapper/HostVG-virtual_377 208845"

	# pripojime device (druha partition) 
	dmsetup_tupple = (dm_name, partition['size'], snapshot_device, partition['start'])
	base.shell_exec('dmsetup create %s --table "0 %s linear %s %s"' % dmsetup_tupple)
	# aktivujeme PV
	base.shell_exec('pvscan; vgchange -ay VirtVG')
	
	# zkontrolujeme a zmensime FS
	base.shell_exec('fsck -f /dev/VirtVG/root')
	base.shell_exec('resize2fs /dev/VirtVG/root %sk' % fs_size_k)
	
	# resize LV
	base.shell_exec('lvresize -f -l%s /dev/VirtVG/root' % lv_size_pe)
	
	# resize PV
	base.shell_exec('pvresize -f --setphysicalvolumesize %sk %s' % (pv_size_k, '/dev/mapper/dm_name'))
	
	# odpojit PV a partition
	base.shell_exec('vgchange -an VirtVG')
	base.shell_exec('dmsetup remove '+dm_name)
	
	# mapper na cely disk s novou velikosti
	dmsetup_tupple = (dm_name, size_in_bytes>>9, snapshot_device, 0)
	base.shell_exec('dmsetup create %s --table "0 %s linear %s %s"' % dmsetup_tupple)
	
	# resize partition
	base.shell_exec("echo 'd\n2\nn\np\n2\n\n\nw\n' | fdisk /dev/mapper/"+dm_name)
	
	# zipneme a zkopirujeme do ciloveho umisteni
	base.shell_exec("dd if=/dev/mapper/"+dm_name+" bs=1M iflag=nonblock | lzop -c > /mnt/install/images/"+target_path)
	# odpojime device
	base.shell_exec('dmsetup remove '+dm_name)
	
	# odstranime snapshot
	base.shell_exec('lvremove -f /dev/'+vg_name+'/'+snapshot_name)
	
	
def vhost_restore_image(vhost, volume_group, resize = False, windows = False, force = False):
	# default_image_path='/mnt/install/'+vhost['image_type']+'-image.img.lzo'
	default_image_path='/mnt/install/images/'+vhost['image']['path']
	if os.path.exists("%s.meta" % default_image_path):
		# mame image v systemu vps-backup
		default_image_path += ".meta"
		vps_backup_image = True
	else:
		vps_backup_image = False
		if not (os.path.isfile(default_image_path) and os.access(default_image_path, os.R_OK)):
			raise IOError('Unable to find image file %s' % default_image_path)
	
	chroot = '/tmp/virtroottemp'
	lv_device = '/dev/'+volume_group+'/'+vhost['name']
	dm_name = 'temp-'+vhost['name']
	dm_device = '/dev/mapper/'+dm_name
	if resize and int(vhost['image']['resize']) == 0:
		resize = False
	
	if resize:
		coef = 0.8
	else:
		coef = 1
	
	if os.system('lvs %s/thinpool >/dev/null 2>&1' % (volume_group,)) == 0:
		thin_provisioning = True
	else:
		thin_provisioning = False

	
	# pokud se neco predtim posralo, radeji procistime zarizeni
	base.set_current_status('0.0')
	if vps_backup_image:
		archiv = base.get_varch_name()
		myname, mypath = (None,None)
		fh = open(default_image_path)
		try:
			myname, mypath = fh.read().strip().split()
		except:
			raise ValueError('Unable to get image description!')
		fh.close()
		images = rfoo.marsh.loads(base.shell_exec('python /root/server/virtual/vps-backup/manage.py -a %s -n %s -j list' % (archiv,myname)))
		filesize = None
		for image in images:
			if image['path'] == mypath:
				filesize = image['size']
				break
		if type(filesize) == None:
			raise ValueError('Image not found')
		fh = os.open(lv_device, 0)
		lvsize = os.lseek(fh, 0, 2)
		os.close(fh)
	else:
		bs=1024*1024
		# zapiseme novy image
		filesize = int(base.shell_exec('lzop -l '+default_image_path).split('\n')[1].split()[2])
		lzop = subprocess.Popen(['lzop', '-cd'], stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=None)
		infile = dioutil.DioFile()
		infile.open(default_image_path)
		writer = threading.Thread(target=base.pipeWriter, args=(infile,lzop.stdin, bs, True))
		writer.start()
		os.system('ionice -c3 -p'+str(lzop.pid))
		os.system('ionice -c3 -p'+str(os.getpid()))
		outfile = dioutil.DioFile()
		outfile.open(lv_device, os.O_WRONLY)
		lvsize = outfile.getsize()
		outfile.close()
	if filesize > lvsize:
		ret = -1
		# pokud je image vetsi nez lv
		if filesize - lvsize < 1024*1024*100:
			# pokud je rozdil mensi nez 100MB, zkusime zvetsit lv
			ret = os.system('lvresize -L%db %s </dev/null >/dev/null 2>&1' % (filesize, lv_device))
		if ret != 0:
			raise IOError((errno.ENOSPC, 'Image bigger than target volume! (%d/%d)' % (filesize,lvsize)))
	if vps_backup_image:		
		if thin_provisioning and os.system('lvs %s/%s >/dev/null 2>&1' % (volume_group,mypath,)) == 0:
			# pokud image uz mame ve snapshotu, udelame jen snapshot a zajistime spravne velikosti
			target_size = base.shell_exec('lvs -o lv_size --units B --noheadings %s' % (lv_device,)).strip().strip('B')
			source_size = base.shell_exec('lvs -o lv_size --units B --noheadings %s/%s' % (volume_group,mypath)).strip().strip('B')
			base.shell_exec('lvremove -f %s' % (lv_device,))
			ret = base.shell_exec2('lvcreate -n %s -k n -s %s/%s' % (vhost['name'],volume_group,mypath))
			if ret[2] != 0:
				raise IOError((errno.EINTR, 'Unable to restore snapshot image %s %s: %s %s' % (myname, mypath,ret[0], ret[1])))
			if target_size != source_size:
				ret = base.shell_exec2('lvresize -f -L%sB %s' % (target_size,lv_device))
		else:
			params = ['python','/root/server/virtual/vps-backup/restore.py','-a',archiv,'-n',myname,'-p',mypath,'-d',lv_device]
			if force:
				params.append('-f')
			restore_process = subprocess.Popen(params, stdin=None, stdout=None, stderr=subprocess.PIPE)
			statusfile = '/dev/shm/vps-backup-process-status.%d' % restore_process.pid
			errstr = ''
			while restore_process.poll() == None:
				if len(select.select([restore_process.stderr], [], [], 5)[0]) > 0:
					errstr += restore_process.stderr.read()
				try:
					fh = open(statusfile)
					outbytes = fh.readline().strip()
					fh.close()
					base.set_current_status(str((float(outbytes)/float(filesize))*coef))
				except:
					pass
			if restore_process.returncode != 0:
				if len(select.select([restore_process.stderr], [], [], 5)[0]) > 0:
					errstr += restore_process.stderr.read()
				raise IOError((errno.EINTR, 'Unable to restore image %s %s: %s' % (myname, mypath, errstr)))
			else:
				if thin_provisioning and os.system('lvs %s/%s >/dev/null 2>&1' % (volume_group,mypath)) != 0 and re.match('.*parking_.*', vhost['image']['path']) == None:
					# udelame si snapshot pro pristi restore
					base.shell_exec2('lvcreate -n %s -s %s' % (mypath, lv_device))
					base.shell_exec2('lvresize -f -L%sB %s/%s' % (filesize,volume_group,mypath))
	else:
		outfile.open(lv_device, os.O_WRONLY)
		dta = ''
		rd = ''
		outbytes = 0
		writetimes = []
		sleeptime = 0.005
		d = lzop.stdout.read(bs)
		while d != '':
			try:
				ts = time.time()
				outfile.write(d)
				outbytes += len(d)
				writetime = time.time() - ts
				writetimes.append(writetime)
				if len(writetimes) > 10:
					writetimes.pop(0)
				sleeptime = (sum(writetimes)/len(writetimes))/3
				time.sleep(sleeptime)
				base.set_current_status(str((float(outbytes)/float(filesize))*coef))
				d = lzop.stdout.read(bs)
			except:
				lzop.kill()
				lzop.wait()
				raise
		lzop.wait()
		outfile.close()
		writer.join()
		if outbytes < filesize:
			raise IOError((errno.EINTR, 'Unable to write whole image!'))

	#base.shell_exec('ionice -c3 lzop -cd '+default_image_path+' | ionice -c3 dd of='+lv_device+' bs=256k oflag=nonblock 2>/dev/null')
	# with base.unsafe_locks['vhost_update_base_image_restore']:
	try:
		base.unsafe_locks['vhost_update_base_image_restore'].acquire()
		vg_active = base.shell_exec('ls -1 /dev/mapper/temp-* 2>/dev/null').strip()
		if vg_active != '':
			base.shell_exec('umount /dev/VirtVG/root')
			base.shell_exec('vgchange -an VirtVG')
			devices = vg_active.split('\n')
			for device in devices:
				base.shell_exec('dmsetup remove -f '+device)

		while True:#dirty fix duplicated VirtVG
			vgs = base.shell_exec('vgs')
			if re.search('VirtVG',vgs):
				time.sleep(5)
				continue
			else:
				break
		# pokud resizujeme, zvetsime partitionu
		if resize:
			if windows:
				base.set_current_status('0.99')
				base.unsafe_locks['vhost_update_base_image_restore'].release()
				return
			else:
				resize_partition(lv_device)
		# dmsetup create temp-virtual_377p1 --table "0 20762675 linear /dev/mapper/HostVG-virtual_377 208845"
		if int(vhost['image']['auto']):
			# zjistime partition tabulku a vytahneme si posledni partitionu
			partitions = read_partitions(lv_device)
			partition = partitions.pop()	
			# pripojime device a aktivujeme PV
			dmsetup_tupple = (dm_name, partition['size'], lv_device, partition['start'])
			base.shell_exec('dmsetup create %s --table "0 %s linear %s %s"' % dmsetup_tupple)
			base.shell_exec('pvscan; vgchange -ay VirtVG')
			# pripojime root virtualu
			base.shell_exec('mkdir '+chroot+'; mount /dev/VirtVG/root '+chroot)
			open(chroot+'/var/log/lastlog','w').truncate(0)
			open(chroot+'/var/log/wtmp','w').truncate(0)
			open(chroot+'/root/.bash_history','w').truncate(0)
			open(chroot+'/var/log/messages','w').truncate(0)
			if os.path.exists(chroot+'/etc/udev/rules.d/70-persistent-net.rules'):
				os.unlink(chroot+'/etc/udev/rules.d/70-persistent-net.rules')
			# nastavime collectd
			p = open(chroot+'/etc/collectd.conf','r')
			content = p.read()
			p.close()
			p = open(chroot+'/etc/collectd.conf','w')
			p.write(content.replace('linux_virtual_default', vhost['name']+ '_'+vhost['uuid']))
			p.close()
			# zapiseme heslo pro automatizaci
			p = open(chroot+'/root/.auto_passwd', 'w')
			p.write(base.mkpasswd(vhost['auto_password']))
			p.close()
			# zapiseme heslo root uctu
			p = open(chroot+'/etc/shadow', 'r')
			lines = p.readlines()
			p.close()
			for key in range(len(lines)):
				if re.match('^root\:', lines[key]) != None:
					parts = lines[key].strip('\n').split(':')
					parts[1] = base.mkpasswd(vhost['root_password'])
					lines[key] = ':'.join(parts)+'\n'
			p = open(chroot+'/etc/shadow', 'w')
			p.writelines(lines)
			p.close()
			#promazame host klice pro ssh (pri startu se vygeneruji nove)
			delete_list = ['/etc/ssh/ssh_host_rsa_key','/etc/ssh/ssh_host_rsa_key.pub','/etc/ssh/ssh_host_dsa_key','/etc/ssh/ssh_host_dsa_key.pub','/etc/ssh/ssh_host_key','/etc/ssh/ssh_host_key.pub']
			for myfile in delete_list:
				if os.path.exists(chroot+myfile):
					os.unlink(chroot+myfile)
			# odpojime, deaktivujeme, smazeme device
			base.shell_exec('umount '+chroot+'; rm -rf '+chroot)
			base.shell_exec('vgchange -an VirtVG')
			base.shell_exec('dmsetup remove -f '+dm_name)
			base.set_current_status('0.99')
		base.unsafe_locks['vhost_update_base_image_restore'].release()
	except:
		base.unsafe_locks['vhost_update_base_image_restore'].release()
	# unsafe lock - end

def vhost_create_ip(vhost):
	if vhost['vnc_listen'] == '0.0.0.0':
		return None
	# # Zapsat konfiguraci IP pro VNC
	# iface_file = open('/etc/sysconfig/network-scripts/ifcfg-'+vhost['manage_iface'], 'w')
	# iface_file.write("DEVICE="+vhost['manage_iface']+"\n"+
	# 	"BOOTPROTO=static\n"+
	# 	"IPADDR="+vhost['vnc_listen']+"\n"+
	# 	"NETMASK=255.255.255.0\n"+
	# 	"ONBOOT=yes\n"+
	# 	"IPV6INIT=yes\n")
	# iface_file.close()
	# # Nahodit rozhrani
	# base.shell_exec('ifup '+vhost['manage_iface'])
	pass

def vhost_destroy_ip(vhost):
	if vhost['vnc_listen'] == '0.0.0.0':
		return None
	# iface_files = base.shell_exec('grep -le "'+vhost['vnc_listen']+'" /etc/sysconfig/network-scripts/ifcfg-*').split("\n")
	# try:
	# 	iface = filter(lambda x: re.search(re.escape(vhost['vnc_listen']), x) != None, base.shell_exec('ip ad sh').split('\n'))[0].split().pop().split(':')[0]
	# 	# Shodit adresu
	# 	base.shell_exec('ip addr del '+vhost['vnc_listen']+'/24 dev '+iface+' 2> /dev/null')
	# 	base.shell_exec('ip addr del '+vhost['vnc_listen']+'/32 dev lo 2> /dev/null')
	# except:
	# 	# adresa neni nahozena
	# 	pass
	# # Smazat konfiguraci IP pro VNC
	# for iface in iface_files:
	# 	if os.path.exists(iface):
	# 		os.unlink(iface)
	pass


def vhost_parse_input(vhost_data, param_array):
	error = ''
	vhost = {}
	keys = param_array.keys()
	mydata = base.xml_cut(vhost_data, keys)
	mydata = dict(zip(keys, mydata))
	for key in param_array.keys():
		evaluation = param_array[key]
		variable = mydata[key]
		failed = False
		
		if evaluation.has_key('empty') and variable == '':
			failed = False
		else:
			if evaluation.has_key('ereg') and not re.match(evaluation['ereg'], variable):
				error += "variable " +key+ " failed ereg evaluation\n"
				failed = True
			if evaluation.has_key('eval'):
				r = evaluation['eval'](variable)
				if r != None and len(r) > 0:
					error += "variable " +key+ " failed with message: "+r+"\n";
					failed = True;
		if failed == False:
			if evaluation.has_key('ereg') and evaluation['ereg'] == base.EREG_BOOL:
				if variable == '':
					if evaluation.has_key('default'):
						vhost[key] = evaluation['default']
					else:
						vhost[key] = 0
				else:
					vhost[key] = int(variable)
			else:
				vhost[key] = variable
	if len(error) > 0:
		return error
	else:
		return vhost

def vhost_lvm_status(volume_group, name, units = 'g'):
	stripunit = False
	if units == 'l':
		stripunit = True
		units = base.shell_exec('lvs --noheadings -o vg_extent_size '+volume_group+'/'+name+' 2>/dev/null').strip()
		return {'exists':False}
	
	lvm_text,lvm_err, res = base.shell_exec2('lvs --units '+units+' --noheadings --nameprefixes --unquoted '+volume_group+'/'+name)
	lvm_text = lvm_text.strip()
	lvm = {}
	if res != 0:
		lvm['exists'] = False
	else:
		lvm = {
			'exists' : True,
				'data': {}
			}
		lvm['data'].update(map(lambda x: [x[0], x[1].strip()], map(lambda x: x.split("="), lvm_text.strip().split(" "))))
		if stripunit:
			lvm['data']['LVM2_LV_SIZE'] =lvm['data']['LVM2_LV_SIZE'].replace('.00U', '')
	return lvm
	
def vhost_get_my_pv(volume_group):
	pv_text = base.shell_exec('pvs -o pv_name,pv_pe_alloc_count,vg_name --noheadings --nameprefixes --unquoted | grep LVM2_VG_NAME='+volume_group).strip()
	pvs = map(lambda x: map( lambda y: y.split("=") , x.strip().split(" ")),pv_text.split("\n"))
	result = []
	for pv in pvs:
		mylist = {}
		mylist.update(pv)
		result.append(mylist)
	mypv = None
	for pv in result:
		if mypv == None or int(mypv['LVM2_PV_PE_ALLOC_COUNT']) > int(pv['LVM2_PV_PE_ALLOC_COUNT']):
			mypv = pv
	return mypv['LVM2_PV_NAME']
	
def syscmd_vhost_get(data):
	global state_table
	conn = libvirt.open(None)
	cmd = base.xml_cut(data, "cmd")
	if len(cmd) == 0:
		return [False, "command not set"]
	
	virt_path = '/usr/virt/';
	conf_path = virt_path+'conf/'
	iso_path = '/mnt/install/'
	volume_group = vg_name 
	
	if cmd <> "status":
		return [False, 'unknown command']
	else:
		param_array = {'name': {'ereg': base.EREG_IDENTIFIER}}
		vhost_data = base.xml_cut(data, 'vhost', 'object')
		vhost = vhost_parse_input(vhost_data, param_array)
		if type(vhost) == type(""):
			conn.close()
			return [False, vhost]
		try:
			state_id = conn.lookupByName(vhost['name']).info()[0]
			conn.close()
			return [True, state_table[state_id]]
		except:
			conn.close()
			return [False, "domain not found on this server"]
	
def read_backups():
	complete_list = '/root/server/virtual/backup/data/complete'
	#if os.path
	fh = open(complete_list, 'r')
	lines = fh.readlines()
	fh.close()
	myrequest = None
	backups = []
	for line in lines:
		if line == "[request]\n":
			if myrequest != None:
				backups.append(myrequest)
			myrequest = {}
		else:
			mymatch = re.match('^([a-z]+)=([^=]*)$', line.strip("\n"))
			if mymatch != None:
				myrequest[mymatch.group(1)]=mymatch.group(2)
	if myrequest != None:
		backups.append(myrequest)
	return backups

def write_backups(backup_list, do_write = True):
	complete_list = '/root/server/virtual/backup/data/complete'
	mybuffer = ''
	for backup in backup_list:
		mybuffer += "[request]\n"
		for key in backup.keys():
			mybuffer += key+'='+backup[key]+"\n"
	if do_write:
		fh = open(complete_list, 'w')
		fh.writelines(mybuffer)
		fh.close()
	return mybuffer
	
def set_watchdog_start(virtname, status):
	watchdog_dir = '/etc/libvirt_watchdog'
	if status == None:
		if os.path.exists(os.path.join(watchdog_dir, virtname)):
			status = 1
		else:
			status = 0
	
	# stare nastavovani
	if not os.path.exists(watchdog_dir):
		os.mkdir(watchdog_dir)
	
	if status == 0:
		if os.path.exists(watchdog_dir+'/'+virtname):
			os.unlink(watchdog_dir+'/'+virtname)
	if status == 1:
		open(watchdog_dir+'/'+virtname, 'w').close()
	
	conn = libvirt.open(None)
	try:
		dom = conn.lookupByName(virtname)
	except:
		conn.close()
		return False
	try:
		xml = parseString(dom.XMLDesc(libvirt.VIR_DOMAIN_XML_SECURE | libvirt.VIR_DOMAIN_XML_INACTIVE))
		if len(xml.getElementsByTagName('metadata')[0].getElementsByTagName('c2pauto:metadata')[0].getElementsByTagName('autostart')) == 0:
			xml.getElementsByTagName('metadata')[0].getElementsByTagName('c2pauto:metadata')[0].appendChild(xml.createElement('autostart'))
			xml.getElementsByTagName('metadata')[0].getElementsByTagName('c2pauto:metadata')[0].getElementsByTagName('autostart')[0].appendChild(xml.createTextNode(str(status)))
		else:
			xml.getElementsByTagName('metadata')[0].getElementsByTagName('c2pauto:metadata')[0].getElementsByTagName('autostart')[0].childNodes[0].data = str(status)
		conn.defineXML(xml.toxml())
	except:
		conn.close()
		return False
	conn.close()
	return True

def try_libvirt_migrate(dom,result,*args,**kwargs):
	try:
		dom.migrate(*args,**kwargs)
	except libvirt.libvirtError, e:
		result[0] = False
		result[1] = e.get_error_message()
		return
	except:
		result[0] = False
		result[1] = "Unknown error"
		return
	result[0] = True
	return

def query_block_jobs(vhost):
	qmp_path = "/var/lib/libvirt/qemu/%s.qmpcustom" % (vhost['name'],)
	if not os.path.exists(qmp_path):
		return None
	try:
		s = socket.socket(socket.AF_UNIX)
		s.connect(qmp_path)
		d = s.recv(4096)
		s.send('{ "execute": "qmp_capabilities" }')
		d = s.recv(4096)
		s.send('{ "execute":"query-block-jobs" }')
		d = s.recv(4096)
		s.close()
		j = json.loads(d)
		if not j.has_key('return'):
			return None
		total_size = 0
		total_completed =0
		for dev in j['return']:
			total_size += dev['len']
			total_completed += dev['offset']
		if total_size == 0:
			return 0
		else:
			return max(0,(float(total_completed)/float(total_size))-0.01)
	except:
		return None
	
def syscmd_vhost_migrate(data):
	"""docstring for syscmd_vhost_migrate"""
	virt_path = '/usr/virt/';
	conf_path = virt_path+'conf/'
	iso_path = '/mnt/install/'
	volume_group = vg_name
	default_image_path = '/mnt/install/base-image.img.lzo'
	shutdown_timeout = 60
	param_array = {
		'name' : {'ereg': base.EREG_IDENTIFIER},
		'dest' : {'ereg': base.EREG_DOMAIN_NAME},
		'live' : {'ereg': base.EREG_BOOL, 'empty': True},
		'pv' : {'empty': True},
		'disk_striped': {'ereg': base.EREG_BOOL},
		}
	vhost = vhost_parse_input(data, param_array)
	vhost['direct_storage'] = base.xml_cut(data, 'direct_storage', 'object')
	if type(vhost) != type({}):
		return [False, str(vhost)]
	target_uri = 'qemu+ssh://'+vhost['dest']+'/system'
	# zjistime, jestli existuje virtualni domena, pripadne o ni zapiseme data
	conn = libvirt.open(None)
	try:
		dom = conn.lookupByName(vhost['name'])
	except:
		return [False, 'Domain does not exist.']
	old_domstate = dom.info()[0]	
	# Zjistime, jestli existuje volume, pripadne o nem zapiseme data
	lvm = vhost_lvm_status(volume_group, vhost['name'], 'b')
	if not lvm['exists']:
		return [False, 'Domain lvm does not exist.']
	additional_lvm = vhost_lvm_status(volume_group, vhost['name']+'_a', 'b')
	pid = os.fork()
	if pid < 0:
		return [False, 'Fork failed.']
	elif pid > 0:	
		conn.close()
		return [-1, pid]
	else:
		base.shell_exec('ssh -q root@'+vhost['dest']+' "rm -f /root/server/virtual/cleaner/queue/'+vhost['name']+'.mig /root/server/virtual/cleaner/queue/'+vhost['name']+'"') #pokud do dvou dnu zmigrujeme VPS tam a zpatky, tohle resi problem s nechtenym smazanim
		base.forked = True
		conn = libvirt.open(None)
		dom = conn.lookupByName(vhost['name'])
		backups = read_backups()
		mybackups = []
		outbackups = []
		for backup in backups:
			if backup.has_key('name') and backup['name'] == vhost['name']:
				 mybackups.append(backup)
			else:
				outbackups.append(backup)
		write_backups(outbackups)
		my_backups_text = "\n"+write_backups(mybackups, False)
		try:
			fh = open('/usr/virt/conf/%s.xml' % vhost['name'], 'r')
			xml_string = fh.read()
			fh.close()
		except:
			xml_string = dom.XMLDesc(0)
		xml = parseString(xml_string)
		if not vhost['live'] or old_domstate==libvirt.VIR_DOMAIN_SHUTOFF:
			if old_domstate==libvirt.VIR_DOMAIN_RUNNING: # nastava v pripadech offline migrace + stroj bezi
				vhost_shutdown(vhost['name'], 60)
			else: # V pripadech, ze stroj je vypnuty bez uvazeni nad metodou -> nastavime offline migraci
				vhost['live']=0
			try: dom.undefine()
			except: pass
		conn.close()
		try:
			vhost['ip'] = str(xml.getElementsByTagName('devices')[0].getElementsByTagName('interface')[0].getElementsByTagName('ip')[0].getAttribute('address'))
		except:
			vhost['ip'] = None
		vhost['vnc_listen'] = str(xml.getElementsByTagName('devices')[0].getElementsByTagName('graphics')[0].getAttribute('listen'))
		set_watchdog_start(vhost['name'], 0)
		if re.match('^coh-', socket.gethostname()) == None:
			iface = 'vbr100'
		else:
			iface = 'vbr101'
		dointerface = False
		# if vhost['vnc_listen'] == '0.0.0.0':
		# 	dointerface = False
		# else:
		# 	dointerface = True
		# 	try:
		# 		increment = base.shell_exec('basename `grep  -l -s '+vhost['vnc_listen']+' /etc/sysconfig/network-scripts/ -R` 2> /dev/null').strip().split(':')[1]
		# 	except:
		# 		increment = vhost['vnc_listen'].split('.')[3]
		# 	
		# 	myconfig = tempfile.NamedTemporaryFile()
		# 	myconfig.write("DEVICE="+iface+":"+increment+"\n"+
		# 			"BOOTPROTO=static\n"+
		# 			"IPADDR="+vhost['vnc_listen']+"\n"+
		# 			"NETMASK=255.255.255.0\n"+
		# 			"ONBOOT=yes\n"+
		# 			"IPV6INIT=yes\n")
		# 	myconfig.flush()
		# 	base.shell_exec('scp '+myconfig.name+ ' root@'+vhost['dest']+':/etc/sysconfig/network-scripts/ifcfg-'+iface+':'+increment)
		# 	myconfig.close() # temp soubor se uzavira a smaze se
		
		if base.shell_exec2('ssh -q root@'+vhost['dest']+' lvs HostVG/thinpool >/dev/null 2>&1')[2] == 0:
			thin_provisioning = True
		else:
			thin_provisioning = False
		
		size_of_vps = base.get_file_size('/dev/%s/%s' % (volume_group, vhost['name']))
		if os.system("ssh -q root@%s lvs -o lv_name /dev/%s/%s >/dev/null 2>&1" % (vhost['dest'], volume_group, vhost['name'])) == 0:
			base.shell_exec('ssh -q root@%s "lvresize --force --force -L%s /dev/HostVG/%s"' % (vhost['dest'], lvm['data']['LVM2_LV_SIZE'], vhost['name']))
		else:
			if thin_provisioning:
				base.shell_exec('ssh -q root@'+vhost['dest']+' "lvcreate -n '+vhost['name']+' -V'+lvm['data']['LVM2_LV_SIZE']+' -T '+volume_group+'/thinpool"')
			elif not vhost['disk_striped']:
				if vhost['pv'] == '':
					vhost['pv'] = base.shell_exec('ssh -q root@'+vhost['dest']+' "pvs --noheadings --separator \' \' -o pv_name,vg_name --sort pv_free"  | grep '+vg_name+' | tail -n1 | awk \'{print $1}\'')
				base.shell_exec('ssh -q root@'+vhost['dest']+' "lvcreate -n '+vhost['name']+' -L'+lvm['data']['LVM2_LV_SIZE']+' '+volume_group+' '+vhost['pv']+'; lvchange -r 16384 /dev/'+volume_group+'/'+vhost['name']+'"')
			else:
				pvs = base.shell_exec('ssh -q root@'+vhost['dest']+' "pvs --noheadings -o pv_name,pv_attr,vg_name | egrep \'HostVG$\' | egrep \\" a\\"| wc -l"').strip()
				out = base.shell_exec('ssh -q root@'+vhost['dest']+' "lvcreate -i '+pvs+' -I 1024 -n '+vhost['name']+' -L'+lvm['data']['LVM2_LV_SIZE']+' HostVG; lvchange -r 16384 /dev/HostVG/'+vhost['name']+'"')
		
		if additional_lvm['exists']:
			if os.system("ssh -q root@%s lvs -o lv_name /dev/%s/%s_a >/dev/null 2>&1" % (vhost['dest'], volume_group, vhost['name'])) == 0:
				base.shell_exec('ssh -q root@%s "lvresize --force --force -L%s /dev/HostVG/%s_a"' % (vhost['dest'], additional_lvm['data']['LVM2_LV_SIZE'], vhost['name']))
			else:
				if thin_provisioning and False: # additional nedelame na SSD
					base.shell_exec('ssh -q root@'+vhost['dest']+' "lvcreate -n '+vhost['name']+'_a -V'+additional_lvm['data']['LVM2_LV_SIZE']+' -T '+volume_group+'/thinpool"')
				elif not vhost['disk_striped']:
					if vhost['pv'] == '':
						vhost['pv'] = base.shell_exec('ssh -q root@'+vhost['dest']+' "pvs --noheadings --separator \' \' -o pv_name,vg_name --sort pv_free"  | grep '+vg_name+' | tail -n1 | awk \'{print $1}\'')
					base.shell_exec('ssh -q root@'+vhost['dest']+' "lvcreate -n '+vhost['name']+'_a -L'+additional_lvm['data']['LVM2_LV_SIZE']+' '+volume_group+' '+vhost['pv']+'; lvchange -r 16384 /dev/'+volume_group+'/'+vhost['name']+'_a"')
				else:
					pvs = base.shell_exec('ssh -q root@'+vhost['dest']+' "pvs --noheadings -o pv_name,pv_attr,vg_name | egrep \'HostVG$\' | egrep \\" a\\"| wc -l"').strip()
					thin_pvs = base.shell_exec('ssh -q root@'+vhost['dest']+' "pvs --noheadings -o pv_name,pv_attr,vg_name,lv_name | grep thinpool | awk \'{print $1}\' | uniq | wc -l"').strip()
					pvs = int(pvs) - int(thin_pvs)
					if pvs > 1:
						out = base.shell_exec('ssh -q root@'+vhost['dest']+' "lvcreate -i '+str(pvs)+' -I 1024 -n '+vhost['name']+'_a -L'+additional_lvm['data']['LVM2_LV_SIZE']+' HostVG; lvchange -r 16384 /dev/HostVG/'+vhost['name']+'_a"')
					else:
						out = base.shell_exec('ssh -q root@'+vhost['dest']+' "lvcreate -C y -n '+vhost['name']+'_a -L'+additional_lvm['data']['LVM2_LV_SIZE']+' HostVG; lvchange -r 16384 /dev/HostVG/'+vhost['name']+'_a"')
		
		# migrate secrets
		if len(vhost['direct_storage'].getElementsByTagName('item')) > 0:
			conn = libvirt.open(target_uri)
			for item in vhost['direct_storage'].getElementsByTagName('item'):
				dsn, username, password, ipv4 = base.xml_cut(item, ['dsn', 'username', 'password', 'ipv4'])
				try:
					sc = conn.secretLookupByUsage(libvirt.VIR_SECRET_USAGE_TYPE_ISCSI,"%s_%s" % (dsn,username,))
				except:
					sc = conn.secretDefineXML("<secret ephemeral='no' private='yes'><description>Passphrase for the iSCSI server</description><usage type='iscsi'><target>%s_%s</target></usage></secret>" % (dsn,username,),0)
				sc.setValue(password)
			conn.close()
		
		
		if vhost['live']: ## LIVE migrace ##
			if dointerface:
				base.shell_exec('ip addr del '+vhost['vnc_listen']+'/24 dev '+iface+' 2>&1; rm -f /etc/sysconfig/network-scripts/ifcfg-'+iface+'\:'+increment+ '; sleep 2; ssh -q root@'+vhost['dest']+' "ifup '+iface+':'+increment+'"')
			try:
				target_conn = libvirt.open(target_uri)
			except Exception:
				return [False, traceback.format_exc()]
			
			ml_file = '/var/lock/libvirt_live_migration_%d.lock' % (dom.ID(),)
			ml = open(ml_file, 'w')
			fcntl.flock(ml,fcntl.LOCK_EX)
			
			try:  # posleme migraci ve vlakne na pozadi
				migrate_res = [None, None]
				mythread = threading.Thread(target=try_libvirt_migrate, args=(dom,migrate_res,target_conn, libvirt.VIR_MIGRATE_LIVE | libvirt.VIR_MIGRATE_PEER2PEER | libvirt.VIR_MIGRATE_PERSIST_DEST | libvirt.VIR_MIGRATE_UNDEFINE_SOURCE | libvirt.VIR_MIGRATE_NON_SHARED_DISK | libvirt.VIR_MIGRATE_UNSAFE, vhost['name'], target_uri, 2000))
				mythread.start()
			except:
				target_conn.close()
				return [False, 'Unable to migrate domain!!!\n%s' % (traceback.format_exc(),)]
			res = None
			base.set_current_status('')
			mythread.join(0.1)
			status_updated = time.time()
			status_last = "0"
			status = status_last
			suspended = False
			while mythread.isAlive():
				new_status = query_block_jobs(vhost)
				if new_status == None:
					new_status = base.percents_from_qemu_log(vhost['dest'],vhost['name'])
				if (new_status != None and new_status != 0) or status == None:
					status = str(new_status)
				base.set_current_status(status)
				if status_last != status:
					status_updated = time.time()
					status_last = status
				if (status == "0.99" or status == "1.0") and (time.time() - status_updated > 60*60*2) and not suspended:
					suspended = True
					dom.suspend()
				mythread.join(1.0)
			target_conn.close()
			if not migrate_res[0]:
				return [False, 'Unable to migrate domain!!!\n%s' % migrate_res[1]]
			
			# odstranime zamek
			try:
				ml.close()
				os.unlink(ml_file)
			except:
				pass
			
			# zkontrolujem, jestli na zdrojovem uz nebezi
			conn = libvirt.open(None)
			try:
				time.sleep(6)
				dom = conn.lookupByName(vhost['name'])
				return [False, "Domena nebyla live zmigrovana (zustava aktivni na zdroji)."]
			except: pass
		else: ## OFFLINE migrace ##
			if dointerface:
				base.shell_exec('ip addr del '+vhost['vnc_listen']+'/24 dev '+iface+' 2>&1; \
				 rm -f /etc/sysconfig/network-scripts/ifcfg-'+iface+'\:'+increment+ '; \
				 sleep 2; ssh -q root@'+vhost['dest']+' "ifup '+iface+':'+increment+'" 2>&1')
			
			filesize = base.get_file_size('/dev/%s/%s' % (volume_group, vhost['name']))
			total_filesize = filesize
			current_block = 0
			if additional_lvm['exists']:
				total_filesize += base.get_file_size('/dev/%s/%s_a' % (volume_group, vhost['name']))
			
			infile = dioutil.DioFile()
			infile.open('/dev/%s/%s' % (volume_group, vhost['name']))
			bs=1024*1024
			proc = subprocess.Popen('lzop -c | ssh -q -c arcfour root@%s "lzop -cd | python /root/server/command/ddd.py of=/dev/HostVG/%s bs=1M"' % \
						 (vhost['dest'], vhost['name']), stdin=subprocess.PIPE, stdout=None, stderr=None, shell=True)
			for i in range(filesize//bs):
				current_block += 1
				proc.stdin.write(infile.read(bs))
				base.set_current_status(str(float(current_block*bs)/float(total_filesize)))
			if filesize%bs > 0:
				proc.stdin.write(infile.read(filesize%bs))
			
			infile.close()
			proc.stdin.close()
			
			proc.wait()
			
			if additional_lvm['exists']:
				filesize = base.get_file_size('/dev/%s/%s_a' % (volume_group, vhost['name']))
				infile = dioutil.DioFile()
				infile.open('/dev/%s/%s_a' % (volume_group, vhost['name']))
				bs=1024*1024
				proc = subprocess.Popen('lzop -c | ssh -q -c arcfour root@%s "lzop -cd | python /root/server/command/ddd.py of=/dev/HostVG/%s_a bs=1M"' % \
							 (vhost['dest'], vhost['name']), stdin=subprocess.PIPE, stdout=None, stderr=None, shell=True)
				for i in range(filesize//bs):
					current_block += 1
					proc.stdin.write(infile.read(bs))
					base.set_current_status(str(float(current_block*bs)/float(total_filesize)))
				if filesize%bs > 0:
					proc.stdin.write(infile.read(filesize%bs))

				infile.close()
				proc.stdin.close()

				proc.wait()
			#zapiseme xml konfiguraci na vzdalenem stroji
			t_conn_retry = 0
			while True:
				try: 
					target_conn = libvirt.open(target_uri)
					break
				except: 
					if t_conn_retry < 3:
						t_conn_retry += 1
					else:
						return [False, 'Error opening connection to libvirt on %s' % target_uri]
			try:
				res = target_conn.lookupByName(vhost['name'])
			except:
				try: 
					res = target_conn.defineXML(xml.toxml())
				except: return [False, 'Error defining new XML for domain %s' % vhost['name']]
			if old_domstate==libvirt.VIR_DOMAIN_SHUTOFF: # prom. domain obsahuje info o domene na zdrojovem podkladu.
				open('/root/server/virtual/cleaner/queue/'+vhost['name']+'.mig', 'w').close()
				if additional_lvm['exists']:
					open('/root/server/virtual/cleaner/queue/'+vhost['name']+'_a.mig', 'w').close()
				base.shell_exec('ssh -q root@'+vhost['dest']+' "echo \''+my_backups_text+'\' >> /root/server/virtual/backup/data/complete"')
				return [True, "Domain moved to "+vhost['dest']+" as 'shut off' state."]
			try:
				res.create()
			except: 
				try:
					dom = target_conn.lookupByName(vhost['name'])
				except:
					return [False, 'Unable to start domain on new host']
			target_conn.close()
		if vhost['ip'] != None:
			base.shell_exec('arp -d '+vhost['ip']+'; ping -I '+iface+' -c1 '+vhost['ip'])
		open('/root/server/virtual/cleaner/queue/'+vhost['name']+'.mig', 'w').close()	
		if additional_lvm['exists']:
			open('/root/server/virtual/cleaner/queue/'+vhost['name']+'_a.mig', 'w').close()
		base.shell_exec('ssh -q root@'+vhost['dest']+' "touch /etc/libvirt_watchdog/'+vhost['name']+'; \
				 echo \''+my_backups_text+'\' >> /root/server/virtual/backup/data/complete"')
		if vhost['vnc_listen'] != '0.0.0.0':
			base.shell_exec('ssh -q root@' + vhost['dest'] + ' "ping -c30 -q -I '+ vhost['vnc_listen'] + ' 130.193.8.82 2>&1 >/dev/null"')
		return [True, 'Domain moved to '+vhost['dest']]
	
def toggle_vnc(listen, port, enabled):
	if os.system('iptables -L VNC >/dev/null 2>&1') != 0:
		os.system('iptables -N VNC')
	if os.system('iptables -L INPUT | grep VNC >/dev/null 2>&1') != 0:
		os.system('iptables -I INPUT -j VNC')
	if listen == '0.0.0.0':
		os.system('iptables -D INPUT -p tcp --dport %s -j REJECT 2>/dev/null' % (str(port)),)
		os.system('iptables -D VNC -p tcp --dport %s -j ACCEPT 2>/dev/null' % (str(port)),)
	os.system('iptables -D INPUT -d %s -p tcp --dport %s -j REJECT 2>/dev/null' % (listen, str(port)))
	os.system('iptables -D VNC -d %s -p tcp --dport %s -j ACCEPT 2>/dev/null' % (listen, str(port)))
	if not enabled:
		if listen == '0.0.0.0':
			os.system('iptables -A INPUT -p tcp --dport %s -j REJECT 2>/dev/null' % (str(port)),)
		else:
			os.system('iptables -A INPUT -d %s -p tcp --dport %s -j REJECT 2>/dev/null' % (listen, str(port)))
	else:
		if listen == '0.0.0.0':
			os.system('iptables -A VNC -p tcp --dport %s -j ACCEPT 2>/dev/null' % (str(port)),)
		else:
			os.system('iptables -A VNC -d %s -p tcp --dport %s -j ACCEPT 2>/dev/null' % (listen, str(port)))
	os.system('service iptables save >/dev/null 2>&1')

def power_on(vps_res, max_tries=5):
	tries = 0
	while True:
		if vps_res.info()[0] == libvirt.VIR_DOMAIN_RUNNING:
			break
		try:
			res = vps_res.create()
		except (IOError, libvirt.libvirtError):
			if tries < max_tries:
				tries += 1
				continue
			else:
				raise
		except:
			if vps_res.info()[0] != libvirt.VIR_DOMAIN_RUNNING:
				raise
			else:
				pass
		time.sleep(1)
	return True

def syscmd_vhost_update(data):
	cmd = base.xml_cut(data, "cmd")
	if len(cmd) == 0:
		return [False, "command not set"]
	conn = libvirt.open(None)
	if re.match('^coh-', socket.gethostname()) == None:
		iface = 'vbr100'
	else:
		iface = 'vbr101'
	virt_path = '/usr/virt/';
	conf_path = virt_path+'conf/'
	iso_path = '/mnt/install/'
	volume_group = vg_name
	default_image_path = '/mnt/install/base-image.img.lzo'
	shutdown_timeout = 90
	resized = False
	
	if cmd == 'update':
		param_array = {
			'name' : {'ereg': base.EREG_IDENTIFIER},
			'uuid' : {'ereg': base.EREG_UUID},
			'memory_max' : {'ereg': base.EREG_NUMBER, 'eval': (lambda x: (int(x)%1024) and 'value must be multiple of 1024' or None)},
			'memory_min' : {'ereg': base.EREG_NUMBER, 'eval' :  (lambda x: (int(x)%1024) and 'value must be multiple of 1024' or None)},
			'memory_deduplication': {'ereg': base.EREG_BOOL},
			'cpu' : {'ereg': base.EREG_NUMBER, 'eval' : (lambda x: ((int(x) >= 5 ) and 'value must be integer < 5' or None))},
			'threads' : {'ereg': base.EREG_NUMBER, 'eval' : (lambda x: ((int(x) >= 3 ) and 'value must be integer < 3' or None))},
			'disk_space': {'ereg': base.EREG_NUMBER},
			'additional_disk_space': {'ereg': base.EREG_NUMBER},
			'disk_striped': {'ereg': base.EREG_BOOL},
			'iso': {'ereg': base.EREG_ISO, 'empty': True},
			'mac': {'ereg': base.EREG_MAC},
			'vnc_active': {'ereg': base.EREG_BOOL},
			'vnc_listen': {'ereg': base.EREG_IP},
			'vnc_password': {'ereg': base.EREG_PASSWORD},
			'vnc_port': {'ereg': base.EREG_NUMBER},
			'mgmt_increment': {'ereg': base.EREG_NUMBER},
			'standard_base': {'ereg': base.EREG_BOOL},
			'force_resize': {'ereg': base.EREG_BOOL},
			'windows': {'ereg': base.EREG_BOOL, 'empty': True},
			'restart': {'ereg': base.EREG_BOOL},
			'reinstall': {'ereg': base.EREG_BOOL},
			'disable_default_vlan': {'ereg': base.EREG_BOOL},
			'image_type': {'ereg': base.EREG_FILENAME},
			'root_password': {'ereg': base.EREG_PASSWORD},
			'auto_password': {'ereg': base.EREG_PASSWORD},
			'interface': {'ereg': base.EREG_IDENTIFIER},
			'ip': {'preg': base.EREG_IP},
			'ipv4_filter': {'ereg': base.EREG_BOOL},
			'noip': {'ereg': base.EREG_BOOL, 'empty': True},
			'nostart': {'ereg': base.EREG_BOOL, 'empty': True},
			'noinstall': {'ereg': base.EREG_BOOL, 'empty': True},
			'autobackup': {'ereg': base.EREG_BOOL},
			'diskdevice':{},
			'clock_type':{'ereg': base.EREG_TEXT},
			'graphics_type':{'ereg': base.EREG_IDENTIFIER},
			'nic_type':{'ereg': base.EREG_IDENTIFIER},
			'watchdog_type':{'ereg': base.EREG_IDENTIFIER},
			'display_type':{'ereg': base.EREG_IDENTIFIER},
			'disk_cache':{'ereg': base.EREG_IDENTIFIER},
			'rtc_tickpolicy':{'ereg': base.EREG_IDENTIFIER},
			'hyperv_extensions':{'ereg': base.EREG_BOOL},
			'nwfilter_name' : {'ereg': base.EREG_IDENTIFIER, 'empty': True},
			'limit_traffic_in' : {'ereg': base.EREG_NUMBER, 'empty': True},
			'limit_traffic_out' : {'ereg': base.EREG_NUMBER, 'empty': True},
			'power_switch': {'ereg': base.EREG_BOOL},
			'vendor' : {'ereg':base.EREG_TEXT},
			'disk_io_weight' : {'ereg':base.EREG_NUMBER},
			'cpu_share' : {'ereg':base.EREG_NUMBER},
			'cpu_quota' : {'ereg':base.EREG_NUMBER},
			'cpu_hard_quota' : {'ereg':base.EREG_NUMBER},
			'disk_read_mbps' : {'ereg':base.EREG_NUMBER},
			'disk_write_mbps' : {'ereg':base.EREG_NUMBER},
			'disk_read_iops' : {'ereg':base.EREG_NUMBER},
			'disk_write_iops' : {'ereg':base.EREG_NUMBER},
			'blocked_network': {'ereg': base.EREG_BOOL, 'empty': False}
		}
		vhost_data = base.xml_cut(data, "vhost", 'object')
		vhost = vhost_parse_input(vhost_data, param_array)
		if type(vhost) != type({}):
			return [False, str(vhost)]
		mymatch = re.match('^virtual_([0-9]+)$', vhost['name'])
		if mymatch != None:
			vhost['recid'] = mymatch.group(1)
		else:
			vhost['recid'] = None
		if vhost['standard_base']:
			vhost['image'] = dict(zip(['path', 'resize', 'auto', 'windows'],base.xml_cut(base.xml_cut(data, "image", 'object'), ['path', 'resize', 'auto', 'windows'])))
		vhost['vlans'] = base.xml_cut(vhost_data, 'vlans', 'object')
		vhost['nwfilter'] = base.xml_cut(vhost_data, 'nwfilter', 'object')
		vhost['direct_storage'] = base.xml_cut(vhost_data, 'direct_storage', 'object')
		
		if not vhost['vnc_active']:
			toggle_vnc(vhost['vnc_listen'], vhost['vnc_port'], False)
		else:
			toggle_vnc(vhost['vnc_listen'], vhost['vnc_port'], True)
		
		if not vhost.has_key('reinstall'):
			vhost['reinstall'] = 0
			
		if type(vhost) == type(""):
			return [False, vhost]
		
		if len(vhost['iso']) > 0:
			vhost['iso'] = ";".join(map(lambda x: iso_path+x, vhost['iso'].split(";")))
		else:
			vhost['iso'] = ''
		vhost['disk'] = '/dev/'+volume_group+'/'+vhost['name']
		exploded_ip = vhost['vnc_listen'].split(".")
		# vhost['vnc_port'] = "5900"
		# TODO: manage iface urcit podle vlany do ktere patri
		vhost['manage_iface'] = iface+':'+str(int(exploded_ip[3])+int(vhost['mgmt_increment']))
		# mame hotovou definici vhostu
		# zjistime, jestli existuje virtualni domena, pripadne o ni zapiseme data
		api_domain = {'res':None, 'info':None}
		try:
			api_domain['res'] = conn.lookupByName(vhost['name'])
			api_domain['info'] = api_domain['res'].info()
		except:
			api_domain['res'] = None
		if os.path.exists('/root/server/virtual/cleaner/queue/%s.mig' % (vhost['name'],)):
			os.unlink('/root/server/virtual/cleaner/queue/%s.mig' % (vhost['name'],))
		if os.path.exists('/root/server/virtual/cleaner/queue/%s' % (vhost['name'],)):
			os.unlink('/root/server/virtual/cleaner/queue/%s' % (vhost['name'],))
			time.sleep(5)
		# Zjistime, jestli existuje volume, pripadne o nem zapiseme data
		lvm = vhost_lvm_status(volume_group, vhost['name'])
		additional_lvm = vhost_lvm_status(volume_group, vhost['name']+'_a')
			
		if api_domain['res'] is None:
			restore_image = False
			if (vhost['standard_base']):
				if vhost['reinstall']:
					restore_image = True
				vhost['reinstall'] = 0
			else:
				vhost['reinstall'] = 1
			
			try:
				if not vhost['noip']:
					vhost_create_ip(vhost)
				api_domain['res'] = conn.defineXML(vhost_virsh_xml(vhost))
				api_domain['info'] = api_domain['res'].info()
			except:
				return [False, 'Unable to define domain!\n'+traceback.format_exc()]
			if not (lvm.has_key('exists') and lvm['exists']):
				res = lvcreate_disk_space(volume_group,vhost['name'],vhost['disk_space'],vhost['disk_striped'],create_new_vps=True)
				if res[0].find("created") == -1:
					api_domain['res'].undefine()
					return [False, "unable to create logical volume: %s" % (res[1],)]
				if vhost['standard_base'] and not vhost['noinstall']:
					restore_image = True
			if restore_image:
				pid = os.fork()
				if pid < 0:
					return [False, 'Fork failed.']
				elif pid > 0:
					conn.close()
					return [-1, pid]
				else:
					base.forked = True
				try:
					vhost_restore_image(vhost, volume_group, vhost['disk_space'] > 5, int(vhost['image']['windows']), force=True)
				except:
					conn = libvirt.open(None)
					api_domain['res'] = conn.lookupByName(vhost['name'])
					api_domain['res'].undefine()
					vhost_destroy_ip(vhost)
					return [False, 'unable to copy image - reverting creation\n'+traceback.format_exc()]
				# pokud bezi restore, je dost mozne, ze nam vytimeoutuje conn, obnovime teda resource
				conn = libvirt.open(None)
				api_domain['res'] = conn.lookupByName(vhost['name'])
			if re.search('_ks$',vhost['image_type']): # pro centose s ks musime dat disketu s kickstartem 
				passed,ret_msg = floppy_with_kickstart(vhost['name'],vhost['image_type'],vhost['root_password'])
				if not passed:
					return [False,ret_msg]
			if int(vhost['additional_disk_space']) > 0 and not (additional_lvm.has_key('exists') and additional_lvm['exists']):
				res = lvcreate_disk_space(volume_group,vhost['name'],vhost['additional_disk_space'],vhost['disk_striped'],create_additional_disk_space=True)
				
			if not vhost['nostart'] and vhost['power_switch']:
				try:
					power_on(api_domain['res'])
				except:
					return [False, 'unable to start domain - reverting creation\n'+traceback.format_exc()]
				set_watchdog_start(vhost['name'], 1)
			if vhost['reinstall']:
				vhost['reinstall'] = 0
				try:
					api_domain['res'] = conn.defineXML(vhost_virsh_xml(vhost))
					api_domain['info'] = api_domain['res'].info()
					base.shell_exec2("rm -f /tmp/floppy_%s.img /tmp/ks_%s.cfg" % (vhost['name'],vhost['name']))
				except:
					pass
			return [True , 'created new VPS.']
		else:
			# uprava jiz existujici domeny
			if (vhost.has_key('reinstall') and vhost['reinstall']) or (vhost.has_key('restart') and vhost['restart']):
				if vhost.has_key('reinstall') and vhost['reinstall']:
					shutdown_timeout=0
				if api_domain['info'][0] != libvirt.VIR_DOMAIN_SHUTOFF:
					ret = vhost_shutdown(vhost['name'], shutdown_timeout)
					if ret[0] == False:
						return ret
				# menime velikost volumu
				passed,ret_msg = lvm_resize(volume_group,vhost['name'],vhost['disk_space'],lvm['data']['LVM2_LV_SIZE'].strip('gG'),force_resize=vhost['force_resize'])
				if not passed:
					return [False,ret_msg]
##				if float(lvm['data']['LVM2_LV_SIZE'].strip('gG')) < float(vhost['disk_space']) or vhost['force_resize'] == 1:
##					res = base.shell_exec('lvchange -Cn '+volume_group+'/'+vhost['name']+' 2>&1')
##					if res.find('changed') == -1 and res.find('already inherit') == -1:
##						return [False, res]
##					res = base.shell_exec('lvresize -f -L'+vhost['disk_space']+'G '+volume_group+'/'+vhost['name']+' 2>&1')
##					if res.find('successfully resized') == -1 and res.find('matches existing size') == -1:
##						return [False, res]
##					res = base.shell_exec('lvchange -Cy '+volume_group+'/'+vhost['name']+' 2>&1')
##					if res.find('changed') == -1 and res.find('already contiguous') == -1:
##						return [False, res]
##				elif float(lvm['data']['LVM2_LV_SIZE'].strip('gG')) > float(vhost['disk_space']):
##					# nepodporujeme zmenseni volumu, budeme tise ignorovat
##					pass

				if int(vhost['additional_disk_space']) > 0:
					if not (additional_lvm.has_key('exists') and additional_lvm['exists']):
						res = lvcreate_disk_space(volume_group,vhost['name'],vhost['additional_disk_space'],vhost['disk_striped'],create_additional_disk_space=True)
					else:
						passed,ret_msg = lvm_resize(volume_group,vhost['name'],vhost['additional_disk_space'],additional_lvm['data']['LVM2_LV_SIZE'].strip('gG'),resize_additional_disk_space=True)
						if not passed:
							return [False,ret_msg]
##					elif float(additional_lvm['data']['LVM2_LV_SIZE'].strip('gG')) < float(vhost['additional_disk_space']):
##						res = base.shell_exec('lvresize -f -L'+vhost['additional_disk_space']+'G '+volume_group+'/'+vhost['name']+'_a 2>&1')
##						if res.find('successfully resized') == -1 and res.find('matches existing size') == -1:
##							return [False, res]
##					elif float(additional_lvm['data']['LVM2_LV_SIZE'].strip('gG')) > float(vhost['additional_disk_space']):
##						# nepodporujeme zmenseni volumu, budeme tise ignorovat
##						pass
				elif (additional_lvm.has_key('exists') and additional_lvm['exists']):
					# odstranujeme ext
					open("/root/server/virtual/cleaner/queue/"+vhost['name']+"_a", "w").close()
					
				if ((vhost['standard_base'] and int(vhost['image']['resize']) == 1) or vhost['force_resize'] == 1) and not vhost['reinstall']:
					if int(vhost['image']['windows']) == 0:
						result = resize_partition('/dev/'+volume_group+'/'+vhost['name'])
						fd = open('/tmp/'+vhost['name']+'.resize.log','w')
						fd.write("resize_partition() - %s" % result)
						fd.close()
				if vhost['image_type'] == 'centos6_web_ks': #TODO: nejak sjednotit s predchozi podminkou.Takhle sice prasarna, ale prehledne
					resize_partition('/dev/'+volume_group+'/'+vhost['name'])

				if vhost.has_key('reinstall') and vhost['reinstall']:
					# reinstal
					if vhost['standard_base']:
						pid = os.fork()
						if pid < 0:
							return [False, 'Fork failed.']
						elif pid > 0:	
							conn.close()
							return [-1, pid]
						else:
							base.forked = True
						try:
							vhost_restore_image(vhost, volume_group, vhost['disk_space'] > 5, int(vhost['image']['windows']))
						except:
							return [False, 'unable to restore image, domain is now inactive!!!\n'+traceback.format_exc()]
						# pokud bezi restore, je dost mozne, ze nam vytimeoutuje conn, obnovime teda resource
						conn = libvirt.open(None)
						api_domain['res'] = conn.lookupByName(vhost['name'])
						vhost['reinstall'] = 0
					if re.search('_ks$',vhost['image_type']): # pro centose s ks musime dat disketu s kickstartem 
						passed,ret_msg = floppy_with_kickstart(vhost['name'],vhost['image_type'],vhost['root_password'])
						if not passed:
							return [False,ret_msg]
				vhost_create_ip(vhost)
				try:
					api_domain['res'] = conn.defineXML(vhost_virsh_xml(vhost))
				except:
					return [False, 'unable to re-define domain, domain is now inactive!!!\n'+traceback.format_exc()]
				if not vhost['nostart'] and vhost['power_switch']:
					try:
						power_on(api_domain['res'])
					except:
						return [False, 'unable to re-start domain, domain is now inactive!!!\n'+traceback.format_exc()]
					set_watchdog_start(vhost['name'], 1)
				else:
					set_watchdog_start(vhost['name'], 0)
				
				if vhost['reinstall']:
					vhost['reinstall'] = 0
					try:
						api_domain['res'] = conn.defineXML(vhost_virsh_xml(vhost))
						base.shell_exec2("rm -f /tmp/floppy_%s.img /tmp/ks_%s.cfg" % (vhost['name'],vhost['name']))
					except:
						pass
				return [True, 'domain updated and re-started']
			else:
				# nemame restart ani reinstall
				# za behu muzeme i zvetsit LV
				passed,ret_msg = lvm_resize(volume_group,vhost['name'],vhost['disk_space'],lvm['data']['LVM2_LV_SIZE'].strip('gG'),resize_za_behu=True)
				if not passed:
					return [False,ret_msg]
##				if float(lvm['data']['LVM2_LV_SIZE'].strip('gG')) < float(vhost['disk_space']):
##					res = base.shell_exec('lvchange -Cn '+volume_group+'/'+vhost['name']+' 2>&1')
##					if res.find('changed') == -1 and res.find('already inherit') == -1:
##						return [False, res]
##					res = base.shell_exec('lvresize -f -L'+vhost['disk_space']+'G '+volume_group+'/'+vhost['name']+' 2>&1')
##					if res.find('successfully resized') == -1 and res.find('matches existing size') == -1:
##						return [False, res]
##					res = base.shell_exec('lvchange -Cy '+volume_group+'/'+vhost['name']+' 2>&1')
##					if res.find('changed') == -1:
##						return [False, res]
# zrejme promenna navyse
# 				error = ''
				# updatujeme konfiguraci aby se aplikovala aspon po dalsim restartu
				vhost_create_ip(vhost)
				try:
					api_domain['res'] = conn.defineXML(vhost_virsh_xml(vhost))
				except:
					return [False, 'unable to re-define domain, it is still running though\n'+traceback.format_exc()]
				# zkontrolujeme stav, ze odpovida power switchi
				api_domain['info'] = api_domain['res'].info()
				if api_domain['info'][0] == libvirt.VIR_DOMAIN_SHUTOFF and vhost['power_switch']:
					# zapneme
					try:
						power_on(api_domain['res'])
					except:
						return [False, 'unable to start domain, domain is now inactive!!!\n'+traceback.format_exc()]
					set_watchdog_start(vhost['name'], 1)
					return [True, 'domain updated and started']
				elif api_domain['info'][0] != libvirt.VIR_DOMAIN_SHUTOFF:
					set_watchdog_start(vhost['name'], vhost['power_switch'])
					
					# pripojime/odpojime disky
					vhost_devices_diff(api_domain['res'])
					
					res = base.shell_exec2("virsh qemu-monitor-command %s '{ \"execute\":\"change\", \"arguments\": { \"device\":\"vnc\", \"target\":\"password\", \"arg\":\"%s\" } } '" % (vhost['name'], vhost['vnc_password']))
					try:
						api_domain['res'].setSchedulerParameters({'vcpu_quota':int(vhost['cpu_quota']), 'cpu_shares':int(vhost['cpu_share']), 'emulator_quota':-1})
					except:
						pass
					
					# na fyzickem nodu zhodime/zvedneme sitovy interface vps-ka
					if vhost['blocked_network']:
						set_network_interface = base.shell_exec2("virsh qemu-monitor-command %s '{ \"execute\":\"set_link\", \"arguments\": { \"name\":\"net0\", \"up\":false } } '" % (vhost['name']))
					else:
						set_network_interface = base.shell_exec2("virsh qemu-monitor-command %s '{ \"execute\":\"set_link\", \"arguments\": { \"name\":\"net0\", \"up\":true } } '" % (vhost['name']))
					
					return [True, 'domain updated while running']
				else:
					return [True, 'domain updated in shut off state']
		# sem bychom se nikdy nemeli dostat		
		return [ False, 'unexpected error']
	elif cmd == 'turnoff':
		param_array = {
			'name': {'ereg': base.EREG_IDENTIFIER},
			'force':{'ereg': base.EREG_NUMBER, 'empty': True},
			'timeout':{'ereg': base.EREG_NUMBER, 'empty': True}
		}
		
		vhost_data = base.xml_cut(data, 'vhost', 'object')
		
		vhost = vhost_parse_input(vhost_data, param_array)
		try:
			dom = conn.lookupByName(vhost['name'])
		except:
			return [ False, 'domain does not exist on this server']
		if dom.info()[0] == libvirt.VIR_DOMAIN_SHUTOFF:
			return [True, 'Domain already shut off']
		
		if vhost['timeout']!='':
			timeout = int(vhost['timeout'])
		else:
			timeout = 70
		if vhost['force']!='' and int(vhost['force']) == 0: #pouze odeslani ACPI signalu, bez validace stavu vypnuti, timeout = nekonecno
			ret = vhost_shutdown(vhost['name'], -1)
		else:
			ret = vhost_shutdown(vhost['name'], timeout)
		if ret[0] == False:
			return ret
		return [True, 'domain shut off']
	elif cmd == 'turnon':
		param_array = {
			'name': {'ereg': base.EREG_IDENTIFIER},
			'force':{'ereg': base.EREG_NUMBER, 'empty': True}
		}
		
		vhost_data = base.xml_cut(data, 'vhost', 'object')
		
		vhost = vhost_parse_input(vhost_data, param_array)
		
		set_watchdog_start(vhost['name'], 1)
		try:
			dom = conn.lookupByName(vhost['name'])
		except:
			return [ False, 'domain does not exist on this server']	
		
		if dom.info()[0] not in [libvirt.VIR_DOMAIN_NOSTATE, libvirt.VIR_DOMAIN_SHUTOFF]:
			return [True, 'Domain already running']
		try:
			ret = power_on(dom) #vice pokusu
		except:
			set_watchdog_start(vhost['name'], 0)
			return [False, 'failed to start domain!!!']
		return [True, 'domain set to autostart']

	elif cmd == 'restart':
		param_array = {
			'name': {'ereg': base.EREG_IDENTIFIER},
			'force':{'ereg': base.EREG_NUMBER, 'empty': True},
			'timeout':{'ereg': base.EREG_NUMBER, 'empty': True}
		}
		
		vhost_data = base.xml_cut(data, 'vhost', 'object')
		
		vhost = vhost_parse_input(vhost_data, param_array)
		try:
			dom = conn.lookupByName(vhost['name'])
		except:
			return [ False, 'domain does not exist on this server']
		if vhost['timeout']!='':
			timeout = int(vhost['timeout'])
		else:
			timeout = 70
		if vhost['force']!='' and int(vhost['force']) == 0: #pouze odeslani ACPI signalu, bez validace stavu vypnuti, timeout = nekonecno
			timeout = 1000
		ret = vhost_shutdown(vhost['name'], timeout)
		if ret[0] == False:
			return ret
		try:
			ret = power_on(dom) #power_on nenastavuje watchdog
		except:
			return [False, 'failed to start domain!!!'+traceback.format_exc()]
		set_watchdog_start(vhost['name'], 1)
		return [True, 'domain restarted']

	elif cmd == 'delete':
		param_array = { 'name': {'ereg': base.EREG_IDENTIFIER}}
		vhost_data = base.xml_cut(data, 'vhost', 'object')
		vhost = vhost_parse_input(vhost_data, param_array)
		
		if type(vhost) == type(""):
			return [False, vhost]

		try:
			dom = conn.lookupByName(vhost['name'])
		except:
			return [False, 'domain does not exists']
			
		lvm = vhost_lvm_status(volume_group, vhost['name'])
		additional_lvm = vhost_lvm_status(volume_group, vhost['name']+"_a")
		
		xml = parseString(dom.XMLDesc(0))

		vhost['vnc_listen'] = str(xml.getElementsByTagName('devices')[0].getElementsByTagName('graphics')[0].getAttribute('listen'))
		set_watchdog_start(vhost['name'], 0)
		if dom.info()[0] != libvirt.VIR_DOMAIN_SHUTOFF:
			ret = dom.destroy() # Returns:	0 in case of success and -1 in case of failure.
			if ret < 0: return [False, 'unable to destroy domain']
		
		if os.path.exists(conf_path+vhost['name']+'.xml'):
			os.unlink(conf_path+vhost['name']+'.xml')

		vhost_destroy_ip(vhost)
		
		if lvm['exists']:
			open("/root/server/virtual/cleaner/queue/"+vhost['name'], "w").close()
		if additional_lvm['exists']:
			open("/root/server/virtual/cleaner/queue/"+vhost['name']+"_a", "w").close()
		try:
			ret = dom.undefine()
		except:
			return [False, 'unable to undefine domain']
		
		return [True, 'domain exterminated, hahaha!!!!']
	else:
		return [False, 'unknown command specified']

def backup_get(myname, subject):
	base_path = "/root/server/virtual/backup/data/"
	myfile = base_path+subject
	if not os.path.exists(myfile):
		return False
	f = open(myfile, 'r')
	if myname == '':
		contents = f.read()
		f.close()
		return False
	else:
		lines = f.readlines()
		f.close()
		items = []
		myitem = {}
		if subject == 'complete':
			archiv = base.get_varch_name()
			diffbackups = rfoo.marsh.loads(base.shell_exec('python /root/server/virtual/vps-backup/manage.py -a %s -n %s -j list' % (archiv,myname)))
			for backup in diffbackups:
				items.append({
					'name':myname,
					'status':'complete',
					'direction':'backup',
					'type':backup['type'],
					'archiv':archiv,
					'backend':'diff',
					'file':'/'.join([myname, backup['type'], backup['path']]),
					'time':time.strftime('%Y%m%d%H%M%S', time.localtime(backup['time'])),
					'id':backup['path']
				})
		appendthis = False
		for line in lines:
			if line.strip() == '[request]':
				if appendthis:
					if myitem.has_key('direction') and myitem['direction'] == 'backup' and myitem.has_key('status') and myitem['status'] == 'complete':
						pass
					else:
						items.append(myitem)
				appendthis = False
				myitem = {}
			elif line.strip() == 'name='+myname:
				appendthis = True
			mymatch = re.match('^([a-z]+)=(.*)$', line.strip())
			if mymatch != None:
				myitem[mymatch.group(1)] = mymatch.group(2)
		if appendthis:
			if myitem.has_key('direction') and myitem['direction'] == 'backup' and myitem.has_key('status') and myitem['status'] == 'complete':
				pass
			else:
				items.append(myitem)
	return items

def syscmd_vhost_backup_get(data):
	subject = base.xml_cut(data, "subject")
	myname = base.xml_cut(data, "name")
	items = backup_get(myname,subject)
	if items == False:
		return [False,'File not found or invalid parameters!']
	ret = ''
	for item in items:
		ret += '[request]\n'
		for key in item.keys():
			ret += key+'='+str(item[key])+'\n'
	return [True, ret]

def syscmd_vhost_backup_restore(data):
	base_path = "/root/server/virtual/backup/"

	myname = base.xml_cut(data, "name")
	myid = base.xml_cut(data, "id")
	item = {}
	if myid:
		items = backup_get(myname,'complete')
		for item in items:
			if item.has_key('id') and item['id'] == myid:
				#heureka
				if item.has_key('name'): name = item['name']
				if item.has_key('type'): mytype = item['type']
				if item.has_key('backend'): backend = item['backend']
				if item.has_key('file'):
					if backend == 'diff':
						mytime = item['file'].split('-', 2)[2]
					else:
						mytime = item['file'].split('-', 1)[1]
				if item.has_key('archiv'): archiv = item['archiv']
				break
	
	if item == {}:
		name = base.xml_cut(data, "name")
		mytype = base.xml_cut(data, "type")
		mytime = base.xml_cut(data, "time")
		backend = base.xml_cut(data, "backend")
		archiv = base.get_varch_name()
	
	if backend == '':
		backend = 'fs'
	cwd = os.getcwd()
	os.chdir(base_path)
	res = base.shell_exec2('python insert.py -a '+archiv+' -t '+mytype+' -d restore -n '+name+' -b '+backend+' -i '+mytime)
	os.chdir(cwd)
	if res[2] == 0:
		return [True, str(res[0])+str(res[1])]
	else:
		return [False, str(res[0])+str(res[1])]
	
def syscmd_vhost_backup_backup(data):
	base_path = "/root/server/virtual/backup/"
	name = base.xml_cut(data, "name")
	mytype = base.xml_cut(data, "type")
	backend = base.xml_cut(data, "backend")
	cwd = os.getcwd()
	archiv = base.get_varch_name()
	
	if backend == '':
		backend = 'fs'
	
	os.chdir(base_path)
	res = base.shell_exec2('python insert.py -a '+archiv+' -t '+mytype+' -d backup -b '+backend+' -n '+name)
	os.chdir(cwd)
	if res[2] == 0:
		return [True, str(res[0])+str(res[1])]
	else:
		return [False, str(res[0])+str(res[1])]
	
def syscmd_vhost_space_map(junk):
	pvdisplay_data = base.shell_exec('pvdisplay -m').split("\n")
	pvs = []
	thinlvs = []
	pvdata = None
	mysegment = None
	for line in pvdisplay_data:
			if line.strip() == '--- Physical volume ---':
					if pvdata != None:
							pvs.append(pvdata)
					pvdata = {}
					parsing = 'pvdata'
					mysegment = None
			elif line.strip() == '--- Physical Segments ---':
					parsing = 'segments'
					pvdata['segments'] = []
			elif parsing == 'pvdata' and line.strip() != '':
					pvdata.update(dict([map(string.strip, line.strip().rsplit('  ', 1))]))
			elif parsing == 'segments':
					ps = re.match('^Physical extent ([0-9]+) to ([0-9]+):$', line.strip())
					if ps != None:
							if mysegment != None:
									pvdata['segments'].append(mysegment)
							mysegment = {'pestart':int(ps.group(1)), 'peend': int(ps.group(2))}
					lv = re.match('^Logical volume\s+(/dev/[a-zA-Z0-9/_\-]+)', line.strip())
					if lv != None:
							mysegment['lv'] = lv.group(1)
					le = re.match('^Logical extents\s+([0-9]+) to ([0-9]+)$', line.strip())
					if le != None:
							mysegment.update({'lvstart':int(le.group(1)), 'lvend':int(le.group(2))})
					if line.strip() == 'FREE':
							mysegment['lv'] = 'FREE'
					if line.strip() == '' and mysegment != None:
							pvdata['segments'].append(mysegment)
							mysegment = None
	if pvdata != None:
			pvs.append(pvdata)
	if os.system("lvs %s/thinpool >/dev/null 2>&1" % (vg_name,)) == 0:
		lvdata = base.shell_exec("lvs --nosuffix --noheadings --units B -o lv_name,lv_size -S 'pool_lv=thinpool'").strip().split('\n')
		if lvdata[0] != '':
			for line in lvdata:
				sp = line.strip().split()
				thinlvs.append({'lv_name':sp[0], 'lv_size':sp[1]})
	xml = parseString('<xml/>')
	for pv in pvs:
		if pv['VG Name'] != vg_name:
			continue
		pvxml = xml.childNodes[0].appendChild(xml.createElement('pv'))
		for key in pv.keys():
			if key == 'segments':
				for segment in pv['segments']:
					segxml = pvxml.appendChild(xml.createElement('segment'))
					for segkey in segment.keys():
						segxml.setAttribute(segkey, str(segment[segkey]))
			else:
				pvxml.setAttribute(key.replace(' ', '_'), pv[key])
	if len(thinlvs) > 0:
		thinlvsxml = xml.childNodes[0].appendChild(xml.createElement('thinpool'))
	for lv in thinlvs:
		lvxml = thinlvsxml.appendChild(xml.createElement('lv'))
		for key in lv.keys():
			lvxml.setAttribute(key.replace(' ', '_'), lv[key])
	return [True, xml.toxml()]

def syscmd_vhost_status_all(junk):
	global state_table
	conn = libvirt.open(None)
	domains = conn.listDomainsID()
	stopped = conn.listDefinedDomains()
	xml = parseString('<xml/>')
	for domid in domains:
		dom = conn.lookupByID(domid)
		vxml = xml.childNodes[0].appendChild(xml.createElement('vserver'))
		vxml.setAttribute('name', dom.name())
		vxml.setAttribute('state', state_table[dom.info()[0]])
	for domname in stopped:
		try:
			dom = conn.lookupByName(domname)
			vxml = xml.childNodes[0].appendChild(xml.createElement('vserver'))
			vxml.setAttribute('name', dom.name())
			vxml.setAttribute('state', state_table[dom.info()[0]])
		except:
			pass
	return [True, xml.toxml()]
	
def syscmd_vhost_list_inet(junk):
	if re.match('^coh-', socket.gethostname()) == None:
		iface = 'vbr100'
	else:
		iface = 'vbr101'
	for i in [0,1]:
		status = base.shell_exec('ip ad list dev '+iface)
		resxml = parseString('<xml/>')
		for line in status.split('\n'):
			mymatch = re.match('^\s+inet\s+([0-9\.\/]+)\s+', line)
			if mymatch != None:
				mynode = resxml.childNodes[0].appendChild(resxml.createElement('inet'))
				mynode.setAttribute('iface', iface)
				mynode.appendChild(resxml.createTextNode(mymatch.group(1)))
		iface = 'lo'
	return [True, resxml.toxml()]

# funkce na vytvareni image
# parametry funkce:
#	<virtual> - jmeno virtual
#	<name> - jmeno image bez .lzo
#	<uid> - ciselne uid uzivatele
#
# pokud je virtual spusteny, dojde k jeho vypnuti a 
# opetovnemu zapnuti po vytvoreni snapshotu.
def syscmd_vhost_make_image(data):
	conn = libvirt.open(None)
	start = 0
	params = vhost_parse_input(data, 
		{'virtual': { 'ereg': base.EREG_IDENTIFIER}, 
			'name': { 'ereg': base.EREG_IDENTIFIER}, 
			'uid': {'ereg': base.EREG_NUMBER},
			'restart': {'ereg': base.EREG_BOOL, 'empty': True, 'default': 1}})
	if type(params) == type(''):
		return [False, params]
	# definujeme adresar a device
	devname = params['virtual']+'-snap-'+''.join(random.choice(string.ascii_lowercase + string.digits) for x in range(10))
	mydev = "/dev/"+vg_name+"/"+devname
	mydir = "/mnt/install/images/"+params['uid']
	# pokud neni podadresar, vyrobime
	try:
		os.mkdir(mydir)
	except OSError, e:
		if not (e.errno == errno.EEXIST and os.path.isdir(mydir)): raise
	try:
		dom = conn.lookupByName(params['virtual'])
	except:
		conn.close()
		return [False, 'virtual guest does not exist']
	
	if dom.info()[0] == libvirt.VIR_DOMAIN_RUNNING:
		start = 1
	# vypnout, kdyz se povede
	ret = vhost_shutdown(params['virtual'], 60)
	# kdyz se nepovede vypnout, tak se ukoncime
	if not ret[0]:
		conn.close()
		return ret
	# vytvorime snapshot
	if os.system('lvs '+vg_name+'/thinpool >/dev/null 2>&1') == 0:
		ret = base.shell_exec2('lvcreate -n%s -s -k n /dev/%s/%s' % (devname, vg_name, params['virtual']))
		thin_provisioning = True
	else:
		ret = base.shell_exec2('lvcreate -n%s -L50GB -s /dev/%s/%s' % (devname, vg_name, params['virtual']))
		thin_provisioning = False
	if ret[2] != 0:
		if start == 1:
			dom.create()
			set_watchdog_start(params['virtual'], 1)
			#dom.setAutostart(1)
		conn.close()
		return [False, 'unable to create snapshot, aborting']
	# ted uz muze vps v pohode bezet. image udelame ze snapshotu
	if ('restart'in params):
		start = params['restart'] and start
	if start == 1:
		try:
			dom.create()
		except:
			sys.stderr.write("Nepodarilo se nastartovat %s \n" % params['virtual'])
			sys.stderr.write(traceback.format_exc())
			pass
		set_watchdog_start(params['virtual'], 1)
		#dom.setAutostart(1)
	if not os.path.exists(mydev):
		ret = base.shell_exec2('lvremove -f %s/%s' % (vg_name, devname))
		if start == 1:
			try:
				dom.create()
			except:
				sys.stderr.write("Nepodarilo se nastartovat %s \n" % params['virtual'])
				sys.stderr.write(traceback.format_exc())
				pass
			set_watchdog_start(params['virtual'], 1)
			#dom.setAutostart(1)
		conn.close()
		return [False, 'block device '+mydev+' doesnt exist']
	pid = os.fork()
	if pid < 0:
		return [False, 'Fork failed.']
	elif pid > 0:	
		conn.close()
		return [-1, pid]
	else:
		base.forked = True
	
	filesize = base.get_file_size(mydev)
	backup_process = subprocess.Popen(['python', '/root/server/virtual/vps-backup/backup.py', '-a', base.get_varch_name(), '-n', 'image_'+params['uid'], '-t', 'image', '-d', mydev, '-o', params['virtual']], stdin=None, stdout=subprocess.PIPE, stderr=None, bufsize=4096)
	statusfile = '/dev/shm/vps-backup-process-status.%d' % backup_process.pid
	while backup_process.poll() == None:
		time.sleep(5)
		try:
			fh = open(statusfile)
			outbytes = fh.readline().strip()
			fh.close()
			base.set_current_status(str((float(outbytes)/float(filesize))))
		except:
			pass
	stdout, stderr = backup_process.communicate()
	if backup_process.returncode != 0 or stdout.strip() == "":
		ret = base.shell_exec2('lvremove -f %s/%s' % (vg_name, devname))
		return [False, 'Nepodarilo se vytvorit image! \n%s' % stderr ]
	fh = open(mydir+'/'+params['name']+'.lzo.meta', 'w')
	backup_path = stdout.strip()
	fh.write('image_%s %s' % (params['uid'], backup_path))
	fh.close()
	# os.system('ionice -c3 -p'+str(os.getpid())+' >/dev/null')
	# bs=1024*1024
	# filesize = base.get_file_size(mydev)
	# outfile = dioutil.DioFile()
	# outfile.open(mydir+'/'+params['name']+'.lzo', os.O_CREAT | os.O_TRUNC | os.O_WRONLY)
	# infile = dioutil.DioFile()
	# infile.open(mydev)
	# 
	# lzop = subprocess.Popen(['/usr/bin/lzop','-c'], stdin=subprocess.PIPE, stdout=subprocess.PIPE, bufsize=4096)
	# writer = threading.Thread(target=base.pipeWriter, args=(lzop.stdout, outfile,bs))
	# writer.start()
	# for i in range(filesize//bs):
	# 	lzop.stdin.write(infile.read(bs))
	# 	base.set_current_status(str(float(i*bs)/float(filesize)))
	# if filesize%bs > 0:
	# 	lzop.stdin.write(infile.read(filesize%bs))
	# infile.close()
	# lzop.stdin.close()
	# lzop.wait()
	# writer.join()
	# outfile.close()
	
	#base.shell_exec("dd if="+mydev+" bs=1M iflag=nonblock | lzop -c > "+mydir+"/"+params['name']+".lzo")
	# odstranime snapshot
	if thin_provisioning and re.match('^parking_.*', params['name']) == None:
		# snapshot si nechame v zaloze
		ret = base.shell_exec2('lvrename %s %s %s' % (vg_name, devname, backup_path))
		ret = base.shell_exec('lvchange -k y -a n %s/%s' % (vg_name,backup_path))
	else:
		ret = base.shell_exec2('lvremove -f %s/%s' % (vg_name, devname))
	return [True, 'Image created: '+mydir+"/"+params['name']+".lzo"]

def dir2xml(d):
	out = ''
	for dirpath, dirnames, filenames in os.walk(d, False):
		for name in filenames:
			out += '<item name="'+name+'" />\n'
		for name in dirnames:
			out += '<item name="'+name+'">'
			out += dir2xml(d+"/"+name)
			out += '</item>'
	return out

# funkce vylistuje image
# argument - adresar uid
# vraci zanorovane xml:
# <item name="jmenofajlu">
# parove tagy maji adresare, neparove tagy maji soubory
#
def syscmd_vhost_list_images(uid):
	if uid == None or uid == "":
		return [True, '<ls>' + dir2xml("/mnt/install/images") + '</ls>']
	elif not re.match(base.EREG_NUMBER, uid):
		return [False, 'invalid parameter given']
	elif not os.path.exists("/mnt/install/images/"+uid):
		return [True, '<ls></ls>']
	else:
		return [True, '<ls>' +dir2xml("/mnt/install/images/"+uid) + '</ls>']

# funkce na mazani lzo image
# xml argumenty:
# 	<uid> - daresar daneho uid
#	<name> - jmeno image bez koncovky .lzo
#
def syscmd_vhost_rm_image(data):
	params = vhost_parse_input(data, 
		{
			'path': { 'ereg': base.EREG_IMAGE_PATH}
		})
	# chybny syntax
	if type(params) == type(''):
		return [False, params]
	if os.path.exists("/mnt/install/images/%s.meta" % (params['path'],)):
		fh = open("/mnt/install/images/%s.meta" % (params['path'],))
		name, path = (None,None)
		try:
			name, path = fh.read().strip().split()
		except:
			pass
		fh.close()
		if name == None and path == None:
			return [False, 'nepodarilo se zjistit name a path.']
		stdout,stderr,retcode = base.shell_exec2('python /root/server/virtual/vps-backup/manage.py -a %s -c -n %s -j remove -p %s' % (base.get_varch_name(), name, path))
		if retcode == 0:
			os.unlink("/mnt/install/images/%s.meta" % (params['path'],))
			return [ True, 'image smazan. %s' % stdout ]
		else:
			return [ False, 'image nesmazan (meta). %s' % stderr ]
	# mazat
	try:
		os.unlink("/mnt/install/images/%s" % (params['path'],))
		return [True, 'image smazan']
	except OSError:
		return [False, "image nesmazan /mnt/install/images/%s" % (params['path'],)]

def syscmd_vhost_to_delete(junk):
	if(not os.path.exists('/root/server/virtual/cleaner/queue/')):
		return [False, 'Queue path not found']

	queue = os.listdir('/root/server/virtual/cleaner/queue/')
	retVal = ''
	for elem in queue:
		if(elem[0] == '.'):
			continue
		
		elem = elem.split('.')
		if(len(elem) == 1):
			retVal += elem[0] + '|std\n'
			
		else:
			retVal += elem[0] + '|' + elem[1] + '\n'
			
	return [True, retVal]

def syscmd_vhost_put_file(data):
	params = vhost_parse_input(data, 
		{'vps_uid': {'ereg': base.EREG_NUMBER},
		 'filename': {'ereg': '^[^/?*\\:\$;{}]+$'},
		 'poweroff_timeout' : {'ereg' : base.EREG_NUMBER },
		 'unzip' : {'ereg': base.EREG_BOOL},
		 'cmd_params' : {'ereg': '.*'},
		 'b64zip': {'ereg': '.*'}})
	# check chybny syntax
	if type(params) == type(''):
		return [False, params]
	vps_name = "virtual_%s" % params['vps_uid']
	if params['unzip']: # rozbalit archiv drive, nez neco zapocnem!
		# unzip is here
		tmp_path = '/tmp/%s_%s/' % (vps_name,params['filename']) 
		if not os.path.exists(tmp_path):
			os.mkdir(tmp_path)
		open(tmp_path + params['filename'],'w+').write(base64.b64decode(params['b64zip'])) # zapisem zip archiv do /tmp/<vps_uid>_<filename>
		zfile = ZipFile(tmp_path + params['filename'])
		if params['filename'] not in zfile.namelist():
			return [False, "File %s not found in zip archive." % params['filename']]
	if os.path.exists('/etc/libvirt_watchdog/'+vps_name):
		poweron = True
	else:
		poweron = False
	pid = os.fork()
	if pid < 0:
		return [False, 'Fork failed.']
	elif pid > 0:	
		return [-1, pid]
	else:
		base.forked = True
	vhost_shutdown(vps_name, 120) #teprve po kontrolach muzem VPS vypnout
	base.set_current_status(0.1)
	cont = subprocess.check_output(['virt-inspector', '-a', '/dev/HostVG/%s' % vps_name])
	import libxml2
	xml = libxml2.parseDoc(cont.encode("UTF-8"))
	root = xml.xpathEval('/operatingsystems/operatingsystem/root')[0].content # vetsinou /dev/sda2
	chroot = '/tmp/virt-inspect-%s_%s' % (vps_name,root.split('/')[-1])
	systemroot = xml.xpathEval('/operatingsystems/operatingsystem/windows_systemroot')[0].content # vetsinou /Windows
	subprocess.check_output(['kpartx', '-s', '-a', '/dev/HostVG/%s' % vps_name])
	try:subprocess.check_output(['mkdir', chroot ])
	except:pass
	try:subprocess.check_output(['mount', '/dev/mapper/HostVG-%sp%s' % (vps_name, root[-1]), chroot])
	except:pass
	try:subprocess.check_output(['mkdir', chroot + '/Temp' ])
	except:pass
	if params['unzip']:
		for name in zfile.namelist():
			if name[-1] == '/': # pokud posledni znak / => adresar
				subprocess.check_output(['mkdir', chroot + '/Temp/' + name ])
				continue 
			open("%s/Temp/%s" % (chroot,name), 'w').write(zfile.read(name))
	else:
		open("%s/Temp/%s" % (chroot,params['filename']), 'w').write(base64.b64decode(params['b64zip']))
	subprocess.check_output(['cp', '/root/server/tools/srvany.exe', chroot + '/Temp/srvany.exe' ])
	bat_content = "sc.exe delete srvany\r\nC:\\Temp\\"+params['filename']+ " " + params['cmd_params'] +"\r\nSLEEP 35\r\nsc.exe stop srvany\r\nDEL \"%~f0\"\r\nSLEEP 16\r\nDEL C:\\Temp\\srvany.exe"
	
	open("%s/Temp/firstboot.bat" % chroot, 'w').write(bat_content)
	base.set_current_status(0.2)
	time.sleep(4)
	subprocess.check_output(['umount', '/dev/mapper/HostVG-%sp%s' % (vps_name, root[-1])])
	time.sleep(5)
	p = subprocess.Popen(['/usr/bin/virt-win-reg', '--merge', '/dev/HostVG/%s' % vps_name, '/root/server/tools/inject_zip.reg'], 0, None, None, subprocess.PIPE, subprocess.PIPE)
	(stdoutdata, stderrdata) = p.communicate()
	if stderrdata or p.returncode:
		return [False, "virt-win-reg failed."]
	conn = libvirt.open(None)
	dom = conn.lookupByName(vps_name)
	power_on(dom)
	# umount, cisteni
	base.set_current_status(0.3)
	cnt = 0
	params['poweroff_timeout'] = int(params['poweroff_timeout'])
	while (dom.info()[0] != libvirt.VIR_DOMAIN_SHUTOFF) and (cnt < params['poweroff_timeout']):
		cnt += 1
		base.set_current_status(round((0.3 + 0.7 / params['poweroff_timeout'] * cnt),4))
		time.sleep(1)
	if cnt >= params['poweroff_timeout']:
		return [False, "Inject timeout, state is unknown. %s sec" % (cnt,)]
	else:
		base.set_current_status(0.9998)
		# mount VPS znovu, smazat /Temp
	if poweron:
		set_watchdog_start(vps_name,1)
		power_on(dom)
	base.rmrf(tmp_path) # rekurzivni promazani rozbaleneho zip adresare
	return [True,"Inject successfully passed after %s sec." % (cnt,)]
	
def syscmd_vhost_sysprep(data):
	params = vhost_parse_input(data, 
		{'vps_uid': {'ereg': base.EREG_NUMBER},
		 'new_vps_password': { 'ereg': base.EREG_PASSWORD},})
	# check chybny syntax
	if type(params) == type(''):
		return [False, params]
	vps_name = "virtual_%s" % params['vps_uid']
	vhost_shutdown(vps_name, 1000) #muze probihat check disku
	unatt = open('/root/server/tools/unattend.xml').read()
	cont = subprocess.check_output(['virt-inspector', '-a', '/dev/HostVG/%s' % vps_name])
	import libxml2
	xml = libxml2.parseDoc(cont.encode("UTF-8"))
	root = xml.xpathEval('/operatingsystems/operatingsystem/root')[0].content # vetsinou /dev/sda2
	chroot = '/tmp/virt-inspect-%s_%s' % (vps_name,root.split('/')[-1])
	systemroot = xml.xpathEval('/operatingsystems/operatingsystem/windows_systemroot')[0].content # vetsinou /Windows
	subprocess.check_output(['kpartx', '-s', '-a', '/dev/HostVG/%s' % vps_name])
	subprocess.check_output(['mkdir', chroot ])
	subprocess.check_output(['mount', '/dev/mapper/HostVG-%sp%s' % (vps_name, root[-1]), chroot])
	subprocess.check_output(['cp', '/root/server/tools/unattend.xml', '%s%s/Panther/unattend.xml' % (chroot, systemroot)])
	subprocess.check_output(['cp', '/root/server/tools/virtio-setup.exe','%s%s/Temp/virtio-setup.exe' % (chroot, systemroot)])
	conn = libvirt.open(None)
	dom = conn.lookupByName(vps_name)
	collectm = open("/root/server/tools/collectm.json").read()
	open("%s/Program Files/CollectM/config/default.json" % chroot, 'w').write(collectm.replace('virtual_default',vps_name + '_' + dom.UUIDString()))
	open("%s/Windows/Panther/unattend.xml" % chroot, 'w').write(unatt.replace('AdminPass123',params['new_vps_password']))
	subprocess.check_output(['umount', chroot ])
	time.sleep(4)
	subprocess.check_output(['kpartx', '-d', '/dev/HostVG/%s' % vps_name])
	subprocess.check_output(['rmdir', chroot])
	power_on(dom, 10)
	set_watchdog_start(vps_name,1)
	conn.close()
	return [True, "Sysprep is done."]

def syscmd_vhost_xml_rpc(data):
	vps, request_string = data.split('\n', 1)
	vport_path = '/var/lib/libvirt/qemu/%s.vport' % (vps,)
	connect_timeout = 15
	if (re.match('^virtual_[0-9]+$', vps) == None or not os.path.exists(vport_path)):
		return [False, 'Invalid VPS: %s' % (vps,)]
	conn = libvirt.open()
	dom = conn.lookupByName(vps)
	if dom == None:
		conn.close()
		return [False, 'Invalid VPS: %s' % (vps,)]
	if dom.info()[0] != 1:
		conn.close()
		return [False, 'VPS not running']
	xml = parseString(dom.XMLDesc())
	conn.close()
	for channel in xml.getElementsByTagName('devices')[0].getElementsByTagName('channel'):
		if channel.getElementsByTagName('source')[0].getAttribute('path') == vport_path:
			if channel.getElementsByTagName('target')[0].getAttribute('state') == 'disconnected':
				# pokud vime, ze demon nebezi, nebudeme to ani zkouset
				return [False, 'Remote endpoint not connected']
			elif channel.getElementsByTagName('target')[0].getAttribute('state') == 'connected':
				# pokud je demon pripojeny, natahneme timeout na 30s
				connect_timeout = 30
			break
	
	myc = base.UHTTPConnection(vport_path, timeout=connect_timeout)
	myc.request('POST', '/', request_string)
	res = myc.getresponse()
	if res.status == 200:
		ret = [True,res.read()]
	else:
		ret = [False,res.read()]
	myc.close()
	return ret
	
# funkce na migrovani image
# parametry funkce:
#	<host_src> - jmeno hosta (zdroj)
#   <host_dst> - jmeno hosta (cil)
#   <uid_src> - ciselne uid uzivatele (zdroj)
#   <uid_dst> - ciselne uid uzivatele (cil) 
#	<name_src> - jmeno image bez .lzo (zdroj)
#	<name_dst> - jmeno image bez .lzo (cil)
#

def syscmd_vhost_migrate_image(data):
# * vhost_migrate_image <xml><host_dst>hc-vh10</host_dst><name_src>image_14091700</name_src><name_dst>image_12053100</name_dst><uid_src>116745</uid_src><uid_dst>10623</uid_dst></xml>;	
	params = vhost_parse_input(data, 
		{'host_dst': { 'ereg': base.EREG_IDENTIFIER}, 
			'name_src': { 'ereg': base.EREG_IDENTIFIER},
			'name_dst': { 'ereg': base.EREG_IDENTIFIER}, 
			'uid_src': {'ereg': base.EREG_NUMBER},
			'uid_dst': {'ereg': base.EREG_NUMBER}})
	if type(params) == type(''):
		return [False, params]

	# where we are?
	host_src = socket.gethostname().strip().split('.')[0].strip()

	if host_src == params['host_dst']:
		# IP adresy archivu
		archiv = base.get_varch_name()
		# source image
		vps_backup_image_file='/mnt/install/images/'+params['uid_src']+'/'+params['name_src']+'.lzo'
		image_metafile_src='/mnt/install/images/'+params['uid_src']+'/'+params['name_src']+'.lzo.meta'
		if os.path.exists(image_metafile_src):
			vps_backup_image = True
		elif os.path.exists(vps_backup_image_file):
			vps_backup_image = False
		else:
			return [False, 'Unable to find neither source image description file nor old version backup image file, aborting!']

		if vps_backup_image == True:
			fh = open(image_metafile_src)
			try:
				image_name_src, image_path_src = fh.read().strip().split()
			except:
				fh.close()
				return [False,'Unable to get source image description, aborting!']
			fh.close()
			images_list_src = rfoo.marsh.loads(base.shell_exec('python /root/server/virtual/vps-backup/manage.py --archiv='+archiv+' --name='+image_name_src+' --action=list'))
			image_filesize_src = None
			for image in images_list_src:
				if image['path'].strip() == image_path_src:
					image_filesize_src = long(image['size'])
					break
			if image_filesize_src == None:
				return [False,'Unable to find source image file, aborting!']
		else:
			image_filesize_src, image_filesize_src_err, image_filesize_src_returncode = base.shell_exec2('lzop -l '+vps_backup_image_file)
			if image_filesize_src_returncode != 0:
				return [False,'Unable to get source image file size, aborting!']
			image_filesize_src = long(image_filesize_src.split('\n')[1].split()[2])	

		# destination image
		image_metafile_dst='/mnt/install/images/'+params['uid_dst']+'/'+params['name_dst']+'.lzo.meta'
		if os.path.exists(image_metafile_dst):
			return [False, "Destination image description file already exists, aborting!"]
		image_name_dst='image_'+params['uid_dst']
		# !!! kontrola je zalozena jen na aktualnim case
		btime = datetime.datetime.now().strftime('%Y-%m-%d-%H-%M-%S')
		image_path_dst=image_name_dst+'-image-'+btime
		images_list_dst = rfoo.marsh.loads(base.shell_exec('python /root/server/virtual/vps-backup/manage.py --archiv='+archiv+' --name='+image_name_dst+' --action=list'))
		image_filesize_dst = None
		for image in images_list_dst:
			if image['path'].strip() == image_path_dst:
				image_filesize_dst = long(image['size'])
				break
		if image_filesize_dst != None:
			return [False,'Destination image file already exists, aborting!']
		
		pid = os.fork()
		if pid < 0:
			return [False, 'Fork failed.']
		elif pid > 0:	
			return [-1, pid]
		else:
			base.forked = True

		# migration process
		if vps_backup_image == True:
			process_1 = subprocess.Popen('python /root/server/virtual/vps-backup/restore.py -a '+archiv+' -n '+image_name_src+' -p '+image_path_src+' -d -', stdin=None, stdout = subprocess.PIPE, stderr=None, shell=True)
			process_2 = subprocess.Popen('python /root/server/virtual/vps-backup/backup.py -a '+archiv+' -n '+image_name_dst+' -t image -d -', stdin=process_1.stdout, stdout = subprocess.PIPE, stderr=None, shell=True)
		else:
			process_1 = subprocess.Popen('cat '+vps_backup_image_file, stdin=None, stdout = subprocess.PIPE, stderr=None, shell = True)
			process_2 = subprocess.Popen('python /root/server/virtual/vps-backup/backup.py -a '+archiv+' -n '+image_name_dst+' -t image -d -', stdin=process_1.stdout, stdout = subprocess.PIPE, stderr=None, shell= True)
		process_1.stdout.close() # Allow process_1 to receive a SIGPIPE if process_2 exits.
		process_2_pid = None
		statusfile = None
		image_path_dst = None
		while process_2.poll() == None:
			time.sleep(3)
			if process_2_pid == None or statusfile == None:
				try:
					process_2_pid = int(base.shell_exec('ps aux | grep '+image_name_dst+' | grep -v grep | grep -v bash | grep -v "/bin/sh"').split()[1])
					statusfile = '/dev/shm/vps-backup-process-status.%d' % process_2_pid
				except:
					pass
			if process_2_pid != None and statusfile != None:
				outbytes, outbytes_err, outbytes_returncode = base.shell_exec2('cat '+statusfile)
				if outbytes_returncode == 0 and outbytes.strip() != '':
					base.set_current_status(str((float(outbytes)/float(image_filesize_src))))
		stdout, stderr = process_2.communicate()
		image_path_dst = stdout.strip()
		if image_path_dst == None or image_path_dst == "":
			return [False,"Something wrong. Unable to get path of destination image!"]

		# jestli se neco pokazilo, smaze se image na cilovem hostu
		if process_2.returncode != 0:
			# jestli zustal na cilovem hostu image, tak se smaze
			image_file_dst_remove, image_file_dst_remove_err, image_file_dst_remove_returncode = base.shell_exec2('python /root/server/virtual/vps-backup/manage.py --archiv='+archiv+' --name='+image_name_dst+' --path='+image_path_dst+' --action=remove')
			return [False,"The migration process terminated unexpectedly!"]

		# kontrola na konec jestli oba image maji stejnou velikost
		images_list_dst = rfoo.marsh.loads(base.shell_exec('python /root/server/virtual/vps-backup/manage.py --archiv='+archiv+' --name='+image_name_dst+' --action=list'))
		image_filesize_dst = None
		for image in images_list_dst:
			if image['path'].strip() == image_path_dst:
				image_filesize_dst = long(image['size'])
				break
		if image_filesize_dst != image_filesize_src:
			image_file_dst_remove, image_file_dst_remove_err, image_file_dst_remove_returncode = base.shell_exec2('python /root/server/virtual/vps-backup/manage.py --archiv='+archiv+' --name='+image_name_dst+' --path='+image_path_dst+' --action=remove')
			message = "Migration completed, however, images have different sizes."
			if image_file_dst_remove_returncode == 0 and image_file_dst_remove.strip() == 'True':
				message += " Incomplete destination image was removed."
			else:
				message += " Unable to remove incomplete destination image: %s." % image_path_dst
			message = message[:-1]+'!'
			return [False,message]

		# zapis image metafile na cilovy host
		image_metafile_dst_directory = '/mnt/install/images/'+params['uid_dst']
		base.shell_exec('mkdir -p %s' % image_metafile_dst_directory)
		if not os.path.exists(image_metafile_dst_directory):
			image_file_dst_remove, image_file_dst_remove_err, image_file_dst_remove_returncode = base.shell_exec2('python /root/server/virtual/vps-backup/manage.py --archiv='+archiv+' --name='+image_name_dst+' --path='+image_path_dst+' --action=remove')
			if image_file_dst_remove_returncode != 0:
				return [False,'Image was migrated. Unable to create directory for destination image description file. Unable to remove image on the destination host!']
			return [False,'Image was migrated. Unable to create directory for destination image description file. Image on the destination host was removed!']
		image_metafile_dst_write, image_metafile_dst_write_err, image_metafile_dst_write_returncode = base.shell_exec2('echo -n '+image_name_dst+' '+image_path_dst+' | cat > '+image_metafile_dst)
		if image_metafile_dst_write_returncode != 0:
			message = 'Image was migrated. Unable to write destination image description file.'
			base.shell_exec2('rmdir %s' % image_metafile_dst_directory)
			if not os.path.exists(image_metafile_dst_directory):
				message+=' Unable to remove directory for destination image description file.'
			else:
				message+=' Directory for destination image description file was removed.' 
			image_file_dst_remove, image_file_dst_remove_err, image_file_dst_remove_returncode = base.shell_exec2('python /root/server/virtual/vps-backup/manage.py --archiv='+archiv+' --name='+image_name_dst+' --path='+image_path_dst+' --action=remove')
			if image_file_dst_remove_returncode != 0:
				message+=' Unable to remove image on the destination host.'
			else:
				message+=' Image on the destination host was removed.'
			message=message[:len(message)-1]+'!'
			return [False,message]
	else:
		# existuje cilovy host?
		cmd ='ping -c 1 -A '+params['host_dst']+' 2>/dev/null'
		process_1 = subprocess.Popen(cmd, stdin=None, stdout = subprocess.PIPE, stderr=None, shell=True)
		stdout, stderr = process_1.communicate()
		if process_1.returncode != 0:
			return [False, "Destination host %s is unreachable, aborting!" % (params['host_dst'])]	

		# IP adresy archivu
		archiv_src = base.get_varch_name()
		archiv_dst, archiv_dst_err, archiv_dst_returncode = base.shell_exec2('ssh -q root@'+params['host_dst']+' "cat /root/.archiv-name.conf"')
		if archiv_dst_returncode != 0:
			return [False, "Unable to find destination archiv, aborting! Error message:\n%s" % (archiv_dst_err)]
		archiv_dst = archiv_dst.strip()

		# source image
		vps_backup_image_file='/mnt/install/images/'+params['uid_src']+'/'+params['name_src']+'.lzo'
		image_metafile_src='/mnt/install/images/'+params['uid_src']+'/'+params['name_src']+'.lzo.meta'
		if os.path.exists(image_metafile_src):
			vps_backup_image = True
		elif os.path.exists(vps_backup_image_file):
			vps_backup_image = False
		else:
			return [False, 'Unable to find neither source image description file nor old version backup image file, aborting!']

		if vps_backup_image == True:
			fh = open(image_metafile_src)
			try:
				image_name_src, image_path_src = fh.read().strip().split()
			except:
				fh.close()
				return [False,'Unable to get source image description, aborting!']
			fh.close()
			images_list_src = rfoo.marsh.loads(base.shell_exec('python /root/server/virtual/vps-backup/manage.py --archiv='+archiv_src+' --name='+image_name_src+' --action=list'))
			image_filesize_src = None
			for image in images_list_src:
				if image['path'].strip() == image_path_src:
					image_filesize_src = long(image['size'])
					break
			if image_filesize_src == None:
				return [False,'Unable to find source image file, aborting!']
		else:
			image_filesize_src, image_filesize_src_err, image_filesize_src_returncode = base.shell_exec2('lzop -l '+vps_backup_image_file)
			if image_filesize_src_returncode != 0:
				return [False,'Unable to get source image file size, aborting!']
			image_filesize_src = long(image_filesize_src.split('\n')[1].split()[2])	

		# destination image
		image_metafile_dst='/mnt/install/images/'+params['uid_dst']+'/'+params['name_dst']+'.lzo.meta'
		image_metafile_dst_check, image_metafile_dst_check_err, image_metafile_dst_check_returncode = base.shell_exec2('ssh root@'+params['host_dst']+' "cat '+image_metafile_dst+'"')
		if image_metafile_dst_check_returncode == 0:
			return [False, "Destination image description file already exists, aborting!"]
		image_name_dst='image_'+params['uid_dst']
		# !!! kontrola je zalozena jen na aktualnim case
		btime = datetime.datetime.now().strftime('%Y-%m-%d-%H-%M-%S')
		image_path_dst=image_name_dst+'-image-'+btime
		images_list_dst = rfoo.marsh.loads(base.shell_exec('ssh root@'+params['host_dst']+' "python /root/server/virtual/vps-backup/manage.py --archiv='+archiv_dst+' --name='+image_name_dst+' --action=list"'))
		image_filesize_dst = None
		for image in images_list_dst:
			if image['path'].strip() == image_path_dst:
				image_filesize_dst = long(image['size'])
				break
		if image_filesize_dst != None:
			return [False,'Destination image file already exists, aborting!']

		pid = os.fork()
		if pid < 0:
			return [False, 'Fork failed.']
		elif pid > 0:	
			return [-1, pid]
		else:
			base.forked = True

		# migration process
		tempfile = "%s%s" % ('/dev/shm/backup-status.',hashlib.md5(str(time.localtime())+str(random.random())).hexdigest())
		if vps_backup_image == True:
			process_1 = subprocess.Popen('python /root/server/virtual/vps-backup/restore.py -a '+archiv_src+' -n '+image_name_src+' -p '+image_path_src+' -d - | lzop -c', stdin=None, stdout = subprocess.PIPE, stderr=None, shell=True)
			process_2 = subprocess.Popen('ssh root@'+params['host_dst']+' "lzop -c -d | python /root/server/virtual/vps-backup/backup.py -a '+archiv_dst+' -n '+image_name_dst+' -t image -d - >'+tempfile+'"', stdin=process_1.stdout, stdout = subprocess.PIPE, stderr=None, shell=True)
		else:
			process_1 = subprocess.Popen('cat '+vps_backup_image_file, stdin=None, stdout = subprocess.PIPE, stderr=None, shell = True)
			process_2 = subprocess.Popen('ssh root@'+params['host_dst']+' "lzop -c -d | python /root/server/virtual/vps-backup/backup.py -a '+archiv_dst+' -n '+image_name_dst+' -t image -d - >'+tempfile+'"', stdin=process_1.stdout, stdout = subprocess.PIPE, stderr=None, shell= True)
		process_1.stdout.close() # Allow process_1 to receive a SIGPIPE if process_2 exits.
		process_2_pid = None
		statusfile = None
		image_path_dst = None
		while process_2.poll() == None:
			time.sleep(3)
			if process_2_pid == None or statusfile == None:
				try:
					process_2_pid = int(base.shell_exec('ssh -q root@'+params['host_dst']+' "ps aux | grep '+image_name_dst+' | grep -v grep | grep -v bash"').split()[1])
					statusfile = '/dev/shm/vps-backup-process-status.%d' % process_2_pid
				except:
					pass
			if process_2_pid != None and statusfile != None:
				outbytes, outbytes_err, outbytes_returncode = base.shell_exec2('ssh -q root@'+params['host_dst']+' "cat '+statusfile+'"')
				if outbytes_returncode == 0 and outbytes.strip() != '':
					base.set_current_status(str((float(outbytes)/float(image_filesize_src))))
			# z docasneho souboru ziska path ciloveho image 
			image_path_dst, image_path_dst_err, image_path_dst_returncode = base.shell_exec2('ssh -q root@'+params['host_dst']+' "cat '+tempfile+'"')
			image_path_dst = image_path_dst.strip()
		stdout, stderr = process_2.communicate()
		# z docasneho souboru ziska path ciloveho image 
		if image_path_dst == None or image_path_dst == "":
			image_path_dst, image_path_dst_err, image_path_dst_returncode = base.shell_exec2('ssh -q root@'+params['host_dst']+' "cat '+tempfile+'"')
			image_path_dst = image_path_dst.strip()
		if image_path_dst == None or image_path_dst == "":
			return [False,"Something wrong. Unable to get path of destination image!"]

		# jestli se neco pokazilo, smaze se image na cilovem hostu
		if process_2.returncode != 0:
			message = "The migration process terminated unexpectedly."
			# jestli zustal na cilovem hostu image, tak se smaze
			image_file_dst_remove, image_file_dst_remove_err, image_file_dst_remove_returncode = base.shell_exec2('ssh -q root@'+params['host_dst']+' "python /root/server/virtual/vps-backup/manage.py --archiv='+archiv_dst+' --name='+image_name_dst+' --path='+image_path_dst+' --action=remove"')
			# smaze docasny soubor
			image_path_remove_dst, image_path_remove_dst_err, image_path_remove_dst_returncode = base.shell_exec2('ssh -q root@'+params['host_dst']+' "rm -f '+tempfile+'"')
			if image_path_remove_dst_returncode != 0:
				message += " Unable to remove temporary file on destination host."
			message = message[:-1]+'!'
			return [False,message]

		# kontrola na konec jestli oba image maji stejnou velikost
		images_list_dst = rfoo.marsh.loads(base.shell_exec('ssh root@'+params['host_dst']+' "python /root/server/virtual/vps-backup/manage.py --archiv='+archiv_dst+' --name='+image_name_dst+' --action=list"'))
		image_filesize_dst = None
		for image in images_list_dst:
			if image['path'].strip() == image_path_dst:
				image_filesize_dst = long(image['size'])
				break
		if image_filesize_dst != image_filesize_src:
			image_file_dst_remove, image_file_dst_remove_err, image_file_dst_remove_returncode = base.shell_exec2('ssh -q root@'+params['host_dst']+' "python /root/server/virtual/vps-backup/manage.py --archiv='+archiv_dst+' --name='+image_name_dst+' --path='+image_path_dst+' --action=remove"')
			message = "Migration completed, however, images have different sizes."
			if image_file_dst_remove_returncode == 0 and image_file_dst_remove.strip() == 'True':
				message += " Incomplete destination image was removed."
			else:
				message += " Unable to remove incomplete destination image: %s." % image_path_dst
			# smaze docasny soubor
			image_path_remove_dst, image_path_remove_dst_err, image_path_remove_dst_returncode = base.shell_exec2('ssh -q root@'+params['host_dst']+' "rm -f '+tempfile+'"')
			if image_path_remove_dst_returncode != 0:
				message += " Unable to remove temporary file on destination host."
			message = message[:-1]+'!'
			return [False,message]

		# zapis image metafile na cilovy host
		image_metafile_dst_directory, image_metafile_dst_directory_err, image_metafile_dst_directory_returncode = base.shell_exec2('ssh root@'+params['host_dst']+' " mkdir -p /mnt/install/images/'+params['uid_dst']+' || exit 1"')
		if image_metafile_dst_directory_returncode != 0:
			image_file_dst_remove, image_file_dst_remove_err, image_file_dst_remove_returncode = base.shell_exec2('ssh root@'+params['host_dst']+' "python /root/server/virtual/vps-backup/manage.py --archiv='+archiv_dst+' --name='+image_name_dst+' --path='+image_path_dst+' --action=remove"')
			if image_file_dst_remove_returncode != 0:
				return [False,'Image was migrated. Unable to create directory for destination image description file. Unable to remove image on the destination host!']
			return [False,'Image was migrated. Unable to create directory for destination image description file. Image on the destination host was removed!']
		image_metafile_dst_write, image_metafile_dst_write_err, image_metafile_dst_write_returncode = base.shell_exec2('echo -n '+image_name_dst+' '+image_path_dst+' | ssh root@'+params['host_dst']+' "cat > '+image_metafile_dst+'"')
		if image_metafile_dst_write_returncode != 0:
			message = 'Image was migrated. Unable to write destination image description file.'
			image_metafile_dst_directory, image_metafile_dst_directory_err, image_metafile_dst_directory_returncode = base.shell_exec2('ssh root@'+params['host_dst']+' " rmdir /mnt/install/images/'+params['uid_dst']+' || exit 1"')
			if image_metafile_dst_directory_returncode != 0:
				message+=' Unable to remove directory for destination image description file.'
			else:
				message+=' Directory for destination image description file was removed.' 
			image_file_dst_remove, image_file_dst_remove_err, image_file_dst_remove_returncode = base.shell_exec2('ssh root@'+params['host_dst']+' "python /root/server/virtual/vps-backup/manage.py --archiv='+archiv_dst+' --name='+image_name_dst+' --path='+image_path_dst+' --action=remove"')
			if image_file_dst_remove_returncode != 0:
				message+=' Unable to remove image on the destination host.'
			else:
				message+=' Image on the destination host was removed.'
			message=message[:len(message)-1]+'!'
			return [False,message]

		# smaze docasny soubor
		image_path_remove_dst, image_path_remove_dst_err, image_path_remove_dst_returncode = base.shell_exec2('ssh -q root@'+params['host_dst']+' "rm -f '+tempfile+'"')
		if image_path_remove_dst_returncode != 0:
			return [False, "Unable to remove temporary file on destination host!"]
		
	return [True, 'Done. Image was migrated.']

# registrace funkci
functions = {
	'vhost_get': syscmd_vhost_get,
	'vhost_update': syscmd_vhost_update,
	'vhost_backup_get': syscmd_vhost_backup_get,
	'vhost_backup_restore': syscmd_vhost_backup_restore,
	'vhost_backup_backup': syscmd_vhost_backup_backup,
	'vhost_migrate': syscmd_vhost_migrate,
	'vhost_space_map': syscmd_vhost_space_map,
	'vhost_status_all': syscmd_vhost_status_all,
	'vhost_list_inet': syscmd_vhost_list_inet,
	'vhost_make_image': syscmd_vhost_make_image,
	'vhost_list_images': syscmd_vhost_list_images,
	'vhost_rm_image': syscmd_vhost_rm_image,
	'vhost_to_delete': syscmd_vhost_to_delete,
	'vhost_sysprep': syscmd_vhost_sysprep,
	'vhost_put_file': syscmd_vhost_put_file,
	'vhost_xml_rpc': syscmd_vhost_xml_rpc,
	'vhost_migrate_image': syscmd_vhost_migrate_image
}

